<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | favorite.php                                                           |
//  +------------------------------------------------------------------------+
require_once('include/initialize.inc.php');
$cfg['menu'] = 'favorite';

$action 		= @$_REQUEST['action'];
$favorite_id	= @$_REQUEST['favorite_id'];

if		($action == '')						home();
elseif	($action == 'editFavorite')			editFavorite($favorite_id);
elseif	($action == 'addFavorite')	 		addFavorite();
elseif	($action == 'saveFavorite') 		saveFavorite($favorite_id);
elseif	($action == 'importPlaylist')		importFavorite($favorite_id, 'import');
elseif	($action == 'addPlaylist')			importFavorite($favorite_id, 'add');
elseif	($action == 'deleteFavorite') 		deleteFavorite($favorite_id);
elseif	($action == 'deleteFavoriteItem')	deleteFavoriteItem($favorite_id);
else	message(__FILE__, __LINE__, 'error', '[b]Unsupported input value for[/b][br]action');




//  +------------------------------------------------------------------------+
//  | Home                                                                   |
//  +------------------------------------------------------------------------+
function home() {
	global $cfg, $db, $nav;
	authenticate('access_favorite');

	if ($cfg['switch_play_mode'] && isset($_GET['play_mode'])) {
		mysqli_query($db, 'UPDATE session
			SET play_mode	= ' . (int) $_GET['play_mode'] . '
			WHERE sid		= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');

		// authenticate('access_favorite');
		header('Location: ' . NJB_HOME_URL . 'favorite.php');
		exit();
	}

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Favorites';
	$nav['url'][]	= null;
	$nav['class'][]	= 'nav';

	if ($cfg['switch_play_mode']) {
		$nav['name'][]	= ($cfg['play_mode']) ? 'Play mode' : 'Stream mode';
		$nav['class'][]	= 'nav';
		$nav['url'][]	= 'favorite.php?play_mode=' . (int) ($cfg['play_mode'] xor 1);
	}
	if ($cfg['play_mode'])
		navPlayerProfile();

	require_once('include/header.inc.php');

	$i = 0;
	$previous_stream = 0;
?>
<table class="border">
<tr class="header">
	<td class="space"></td>
	<td>Playlist</td>
	<td class="textspace"></td>
	<td>Comment</td>
	<td<?php if ($cfg['access_admin']) echo' class="textspace"'; ?>></td>
	<td></td><!-- optional delete -->
	<td><?php if ($cfg['access_admin']) echo'<a href="favorite.php?action=addFavorite&amp;sign=' . $cfg['sign'] . '" title="Add new playlist"><img src="' . $cfg['img'] . 'small_header_new.png" alt="" class="small space"></a>'; ?></td>
	<td class="space"></td>
</tr>
<tr class="<?php echo ($i++ & 1) ? 'even' : 'odd'; ?> mouseover">
	<td></td>
	<td><?php
if ($cfg['play_mode']) 			echo '<a href="javascript:ajaxRequest(\'play.php?action=playSelect&amp;random=generate\');" title="Play playlist"><img src="' . $cfg['img'] . 'small_play.png" alt="" class="small space">Random tracks</a>';
elseif ($cfg['stream_mode'])	echo '<a href="stream.php?action=audio&amp;random=generate" title="Stream playlist"><img src="' . $cfg['img'] . 'small_stream.png" alt="" class="small space">Random tracks</a>';
else 							echo 'Random tracks'; ?></td>
	<td></td>
	<td></td>
	<td></td>
	<td></td>
	<td><?php if ($cfg['access_media']) echo '<a href="genre.php?action=blacklist" title="Edit random blacklist"><img src="' . $cfg['img'] . 'small_edit.png" alt="" class="small"></a>'; ?></td>
	<td></td>
</tr>
<?php
	$query = mysqli_query($db, 'SELECT name, comment, stream, favorite_id FROM favorite WHERE 1 ORDER BY stream, name, comment');
	while ($favorite = mysqli_fetch_assoc($query)) {
		if ($previous_stream != $favorite['stream'] && $i > 0) {
			$i = 0;
			echo '<tr class="section"><td></td><td colspan="2">Radio</td><td colspan="5">Comment</td></tr>' . "\n";
		} ?>
<tr class="<?php echo ($i++ & 1) ? 'even' : 'odd'; ?> mouseover">
	<td></td>
	<td><?php
if ($cfg['play_mode'])			echo '<a href="javascript:ajaxRequest(\'play.php?action=playSelect&amp;favorite_id=' . $favorite['favorite_id'] . '&amp;menu=favorite\');" title="Play playlist"><img src="' . $cfg['img'] . 'small_play.png" alt="" class="small space">' . html($favorite['name']) . '</a>';
elseif ($cfg['stream_mode'])	echo '<a href="stream.php?action=audio&amp;favorite_id=' . $favorite['favorite_id'] . '" title="Stream playlist"><img src="' . $cfg['img'] . 'small_stream.png" alt="" class="small space">' . html($favorite['name']) . '</a>';
else 							echo html($favorite['name']); ?></td>
	<td></td>
	<td><?php echo bbcode($favorite['comment']); ?></td>
	<td></td>
	<td><?php if ($cfg['access_admin']) echo '<a href="favorite.php?action=deleteFavorite&amp;favorite_id=' . $favorite['favorite_id'] . '&amp;sign=' . $cfg['sign'] . '" onclick="return confirm(\'Are you sure you want to delete favorite: ' . html(addslashes($favorite['name'])) . '?\');" title="Delete playlist"><img src="' . $cfg['img'] . 'small_delete.png" alt="" class="small"></a>'; ?></td>
	<td><?php if ($cfg['access_admin']) echo '<a href="favorite.php?action=editFavorite&amp;favorite_id=' . $favorite['favorite_id'] . '" title="Edit playlist"><img src="' . $cfg['img'] . 'small_edit.png" alt="" class="small"></a>'; ?></td>
	<td></td>
</tr>
<?php
		$previous_stream = $favorite['stream'];
	}
	echo '</table>' . "\n";
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Edit favorite                                                          |
//  +------------------------------------------------------------------------+
function editFavorite($favorite_id) {
	global $cfg, $db;
	authenticate('access_admin');

	require_once('include/play.inc.php');

	$query = mysqli_query($db, 'SELECT name, comment, stream FROM favorite WHERE favorite_id = ' . (int) $favorite_id);
	$favorite = mysqli_fetch_assoc($query);
	if ($favorite == false)
		message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]favorite_id not found in database');

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Favorites';
	$nav['url'][]	= 'favorite.php';
	if ($cfg['access_play'])
		$nav['name'][]	= $cfg['player_name'];
	$nav['name'][]	= 'Edit';
	require_once('include/header.inc.php');
?>
<form action="favorite.php" method="post" id="favoriteform">
	<input type="hidden" name="action" value="saveFavorite">
	<input type="hidden" name="favorite_id" value="<?php echo $favorite_id; ?>">
	<input type="hidden" name="sign" value="<?php echo $cfg['sign']; ?>">
<table>
<tr>
	<td>Name:</td>
	<td class="textspace"></td>
	<td><input type="text" name="name" value="<?php echo html($favorite['name']); ?>" maxlength="255" class="edit"></td>
</tr>
<tr class="space"><td colspan="3"></td></tr>
<tr>
	<td>Comment:</td>
	<td></td>
	<td><input type="text" name="comment" value="<?php echo html($favorite['comment']); ?>" maxlength="255" class="edit" <?php echo bbcodeReferenceTitle(); ?>></td>
</tr>
<tr class="space"><td colspan="3"></td></tr>
<tr>
	<td></td>
	<td></td>
	<td>
		<a href="javascript:favoriteform.submit();" class="button">save</a><!--
		--><a href="favorite.php" class="button">cancel</a>
	</td>
</tr>
<tr class="textspace"><td colspan="3"></td></tr>
<tr class="textspace"><td colspan="3"></td></tr>
<tr>
	<td>Stream url (mp3, ogg):</td>
	<td></td>
	<td><input type="text" name="stream_url" value="" maxlength="255" class="edit"></td>
</tr>
<tr class="space"><td colspan="3"></td></tr>
<tr>
	<td>Playlist url (m3u, pls):</td>
	<td></td>
	<td><input type="text" name="playlist_url" value="" maxlength="255" class="edit"></td>
</tr>
<tr class="space"><td colspan="3"></td></tr>
<tr>
	<td></td>
	<td></td>
	<td>
		<a href="javascript:favoriteform.action.value='importPlaylist';favoriteform.submit();" class="button">import</a><!--
		--><a href="javascript:favoriteform.action.value='addPlaylist';favoriteform.submit();" class="button">add</a>
	</td>
</tr>
<tr class="textspace"><td colspan="3"></td></tr>
<tr class="textspace"><td colspan="3"></td></tr>
<tr>
	<td style="vertical-align:top">Tracks:</td>
	<td></td>
	<td>
	<!-- begin indent -->
<table class="border">
<tr class="header">
	<td class="space"></td>
	<td><?php echo $favorite['stream'] ? 'Stream' : 'Title' ?></td>
	<td<?php if ($favorite['stream'] == false) echo ' class="textspace"'; ?>></td>
	<td><?php echo $favorite['stream'] ? '' : 'Artist' ?></td>
	<td class="space"></td>
	<td></td><!-- delete -->
	<td class="space"></td>
</tr>
<?php
	$i = 0;
	$query1 = mysqli_query($db, 'SELECT track_id, stream_url, position FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id . ' ORDER BY position');
	while ($favoriteitem = mysqli_fetch_assoc($query1)) {
		if ($favoriteitem['track_id']) {
			$query2	= mysqli_query($db, 'SELECT artist, title FROM track WHERE track_id = "' . mysqli_real_escape_string($db, $favoriteitem['track_id']) . '"');
			$track	= mysqli_fetch_assoc($query2);
		}
		elseif ($favoriteitem['stream_url']) {
			$track['title']		= $favoriteitem['stream_url'];
			$track['artist']	= '';
		} ?>
<tr class="<?php echo ($i++ & 1) ? 'even' : 'odd'; ?> mouseover">
	<td></td>
	<td><?php
if ($cfg['access_play'] && $favoriteitem['track_id'])
	echo '<a href="javascript:ajaxRequest(\'play.php?action=playSelect&amp;track_id=' . $favoriteitem['track_id'] . '&amp;menu=favorite\');" title="Play track"><img src="' . $cfg['img'] . 'small_play.png" alt="" class="small space">' . html($track['title']) . '</a>';
else
	echo html($track['title']); ?></td>
	<td></td>
	<td><?php echo artisLink($track['artist']); ?></td>
	<td></td>
	<td style="text-align:right"><a href="favorite.php?action=deleteFavoriteItem&amp;favorite_id=<?php echo $favorite_id; ?>&amp;position=<?php echo $favoriteitem['position']; ?>&amp;sign=<?php echo $cfg['sign']; ?>" title="Delete track"><img src="<?php echo $cfg['img']; ?>small_delete.png" alt="" class="small"></a></td>
	<td></td>
</tr>
<?php
	} ?>
</table>
	<!-- end indent -->
	</td>
</tr>
</table>
</form>
<script>
function initialize() {
	document.getElementsByName('name')[0].focus();
}
</script>
<?php
	require_once('include/footer.inc.php');
}





//  +------------------------------------------------------------------------+
//  | Add favorite                                                           |
//  +------------------------------------------------------------------------+
function addFavorite() {
	global $cfg, $db;
	authenticate('access_admin', true, true);
	mysqli_query($db, 'INSERT INTO favorite (name) VALUES ("")');
	$favorite_id = mysqli_insert_id($db);

	editFavorite($favorite_id);
}




//  +------------------------------------------------------------------------+
//  | Save favorite                                                          |
//  +------------------------------------------------------------------------+
function saveFavorite($favorite_id) {
	global $db;
	authenticate('access_admin', true, true);
	$name	 = @$_REQUEST['name'];
	$comment = @$_REQUEST['comment'];
	mysqli_query($db, 'UPDATE favorite SET
		name	= "' . mysqli_real_escape_string($db, $name) . '",
		comment	= "' . mysqli_real_escape_string($db, $comment) . '"
		WHERE favorite_id = ' . (int) $favorite_id);

	home();
}




//  +------------------------------------------------------------------------+
//  | Import favorite                                                        |
//  +------------------------------------------------------------------------+
function importFavorite($favorite_id, $mode) {
	global $cfg, $db;
	authenticate('access_admin', true, true);
	require_once('include/play.inc.php');

	$name			= @$_POST['name'];
	$comment		= @$_POST['comment'];
	$stream_url		= @$_POST['stream_url'];
	$playlist_url	= @$_POST['playlist_url'];


	if ($stream_url != '') {
		$file = array();

		if (preg_match('#^((?:ftp|http|https|mms|mmst|pnm|rtp|rtsp|sdp)://.+)#', $stream_url, $match))
			$file[] = $match[1];
	}
	elseif ($playlist_url != '') {
		$file = array();

		$items = @file($playlist_url, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES) or message(__FILE__, __LINE__, 'error', '[b]Failed to open url:[/b][br]' . $playlist_url);
		foreach ($items as $item) {
			// pls:
			// File1=http://example.com:80
			// m3u:
			// http://example.com:80
			if (preg_match('#^(?:File[0-9]{1,3}=|)((?:ftp|http|https|mms|mmst|pnm|rtp|rtsp|sdp)://.+)#', $item, $match))
				$file[] = $match[1];
		}
	}
	elseif ($cfg['player_type'] == NJB_HTTPQ) {
		$file = httpq('getplaylistfilelist', 'delim=*');
		$file = str_replace('\\', '/', $file);
		$file = explode('*', $file);

		// Get relative directory based on $cfg['media_share']
		foreach ($file as $i => $value) {
			if (strtolower(substr($file[$i], 0, strlen($cfg['media_share']))) == strtolower($cfg['media_share']))
				$file[$i] = substr($file[$i], strlen($cfg['media_share']));
		}
	}
	elseif ($cfg['player_type'] == NJB_MPD) {
		$file = mpd('playlist');
		$file = implode('<seperation>', $file);
		$file = iconv(NJB_DEFAULT_CHARSET, 'UTF-8', $file);
		$file = explode('<seperation>', $file);
	}
	else
		message(__FILE__, __LINE__, 'error', '[b]Player not supported[/b]');


	$stream = 0;
	for ($i = 0; $i < count($file); $i++) {
		if (preg_match('#^(ftp|http|https|mms|mmst|pnm|rtp|rtsp|sdp)://#', $file[$i]))
			$stream = 1;
	}


	if (count($file) > 0) {
		if ($mode == 'import') {
			mysqli_query($db, 'DELETE FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id);
			$offset = 0;
		}

		if ($mode = 'add') {
			$query = mysqli_query($db, 'SELECT position FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id . ' ORDER BY position DESC');
			$track = mysqli_fetch_assoc($query);
			$offset = $track['position'];
		}

		// Update favorite stream status
		mysqli_query($db, 'UPDATE favorite
					SET stream			= "' . (int) $stream . '"
					WHERE favorite_id	= ' . (int) $favorite_id);

		// Don't allow stream_url and track_id in the same playlist!
		if ($stream)	mysqli_query($db, 'DELETE FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id . ' AND track_id != ""');
		else			mysqli_query($db, 'DELETE FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id . ' AND stream_url != ""');
	}


	for ($i = 0; $i < count($file); $i++) {
		$query = mysqli_query($db, 'SELECT track_id FROM track WHERE relative_file = "' . mysqli_real_escape_string($db, $file[$i]) . '"');
		$track = mysqli_fetch_assoc($query);

		if ($stream == 0 && $track['track_id']) {
			$position = $i + $offset + 1;
			mysqli_query($db, 'INSERT INTO favoriteitem (track_id, position, favorite_id)
				VALUES ("' . mysqli_real_escape_string($db, $track['track_id']) . '",
				' . (int) $position . ',
				' . (int) $favorite_id . ')');
		}

		if ($stream == 1 && preg_match('#^(ftp|http|https|mms|mmst|pnm|rtp|rtsp|sdp)://#', $file[$i])) {
			$position = $i + $offset + 1;
			mysqli_query($db, 'INSERT INTO favoriteitem (stream_url, position, favorite_id)
				VALUES ("' . mysqli_real_escape_string($db, $file[$i]) . '",
				' . (int) $position . ',
				' . (int) $favorite_id . ')');
		}
	}

	editFavorite($favorite_id);
}




//  +------------------------------------------------------------------------+
//  | Delete favorite                                                        |
//  +------------------------------------------------------------------------+
function deleteFavorite($favorite_id) {
	global $db;
	authenticate('access_admin', true, true);
	mysqli_query($db, 'DELETE FROM favorite WHERE favorite_id = ' . (int) $favorite_id);
	mysqli_query($db, 'DELETE FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id);
	home();
}




//  +------------------------------------------------------------------------+
//  | Delete favorite item                                                   |
//  +------------------------------------------------------------------------+
function deleteFavoriteItem($favorite_id) {
	global $db;
	authenticate('access_admin', true, true);
	$position = @$_GET['position'];
	mysqli_query($db, 'DELETE FROM favoriteitem
		WHERE favorite_id = ' . (int) $favorite_id . '
		AND position = ' . (int) $position);
	editFavorite($favorite_id);
}
