<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | countrycode.inc.php                                                    |
//  +------------------------------------------------------------------------+
$numeric2code = array(
	4 => 'AF',
	8 => 'AL',
	10 => 'AQ',
	12 => 'DZ',
	16 => 'AS',
	20 => 'AD',
	24 => 'AO',
	28 => 'AG',
	31 => 'AZ',
	32 => 'AR',
	36 => 'AU',
	40 => 'AT',
	44 => 'BS',
	48 => 'BH',
	50 => 'BD',
	51 => 'AM',
	52 => 'BB',
	56 => 'BE',
	60 => 'BM',
	64 => 'BT',
	68 => 'BO',
	70 => 'BA',
	72 => 'BW',
	74 => 'BV',
	76 => 'BR',
	84 => 'BZ',
	86 => 'IO',
	90 => 'SB',
	92 => 'VG',
	96 => 'BN',
	100 => 'BG',
	104 => 'MM',
	108 => 'BI',
	112 => 'BY',
	116 => 'KH',
	120 => 'CM',
	124 => 'CA',
	132 => 'CV',
	136 => 'KY',
	140 => 'CF',
	144 => 'LK',
	148 => 'TD',
	152 => 'CL',
	156 => 'CN',
	158 => 'TW',
	162 => 'CX',
	166 => 'CC',
	170 => 'CO',
	174 => 'KM',
	175 => 'YT',
	178 => 'CG',
	180 => 'CD',
	184 => 'CK',
	188 => 'CR',
	191 => 'HR',
	192 => 'CU',
	196 => 'CY',
	203 => 'CZ',
	204 => 'BJ',
	208 => 'DK',
	212 => 'DM',
	214 => 'DO',
	218 => 'EC',
	222 => 'SV',
	226 => 'GQ',
	231 => 'ET',
	232 => 'ER',
	233 => 'EE',
	234 => 'FO',
	238 => 'FK',
	239 => 'GS',
	242 => 'FJ',
	246 => 'FI',
	248 => 'AX',
	250 => 'FR',
	254 => 'GF',
	258 => 'PF',
	260 => 'TF',
	262 => 'DJ',
	266 => 'GA',
	268 => 'GE',
	270 => 'GM',
	275 => 'PS',
	276 => 'DE',
	288 => 'GH',
	292 => 'GI',
	296 => 'KI',
	300 => 'GR',
	304 => 'GL',
	308 => 'GD',
	312 => 'GP',
	316 => 'GU',
	320 => 'GT',
	324 => 'GN',
	328 => 'GY',
	332 => 'HT',
	334 => 'HM',
	336 => 'VA',
	340 => 'HN',
	344 => 'HK',
	348 => 'HU',
	352 => 'IS',
	356 => 'IN',
	360 => 'ID',
	364 => 'IR',
	368 => 'IQ',
	372 => 'IE',
	376 => 'IL',
	380 => 'IT',
	384 => 'CI',
	388 => 'JM',
	392 => 'JP',
	398 => 'KZ',
	400 => 'JO',
	404 => 'KE',
	408 => 'KP',
	410 => 'KR',
	414 => 'KW',
	417 => 'KG',
	418 => 'LA',
	422 => 'LB',
	426 => 'LS',
	428 => 'LV',
	430 => 'LR',
	434 => 'LY',
	438 => 'LI',
	440 => 'LT',
	442 => 'LU',
	446 => 'MO',
	450 => 'MG',
	454 => 'MW',
	458 => 'MY',
	462 => 'MV',
	466 => 'ML',
	470 => 'MT',
	474 => 'MQ',
	478 => 'MR',
	480 => 'MU',
	484 => 'MX',
	492 => 'MC',
	496 => 'MN',
	498 => 'MD',
	499 => 'ME',
	500 => 'MS',
	504 => 'MA',
	508 => 'MZ',
	512 => 'OM',
	516 => 'NA',
	520 => 'NR',
	524 => 'NP',
	528 => 'NL',
	531 => 'CW',
	533 => 'AW',
	534 => 'SX',
	535 => 'BQ',
	540 => 'NC',
	548 => 'VU',
	554 => 'NZ',
	558 => 'NI',
	562 => 'NE',
	566 => 'NG',
	570 => 'NU',
	574 => 'NF',
	578 => 'NO',
	580 => 'MP',
	581 => 'UM',
	583 => 'FM',
	584 => 'MH',
	585 => 'PW',
	586 => 'PK',
	591 => 'PA',
	598 => 'PG',
	600 => 'PY',
	604 => 'PE',
	608 => 'PH',
	612 => 'PN',
	616 => 'PL',
	620 => 'PT',
	624 => 'GW',
	626 => 'TL',
	630 => 'PR',
	634 => 'QA',
	638 => 'RE',
	642 => 'RO',
	643 => 'RU',
	646 => 'RW',
	652 => 'BL',
	654 => 'SH',
	659 => 'KN',
	660 => 'AI',
	662 => 'LC',
	663 => 'MF',
	666 => 'PM',
	670 => 'VC',
	674 => 'SM',
	678 => 'ST',
	682 => 'SA',
	686 => 'SN',
	688 => 'RS',
	690 => 'SC',
	694 => 'SL',
	702 => 'SG',
	703 => 'SK',
	704 => 'VN',
	705 => 'SI',
	706 => 'SO',
	710 => 'ZA',
	716 => 'ZW',
	724 => 'ES',
	728 => 'SS',
	729 => 'SD',
	732 => 'EH',
	740 => 'SR',
	744 => 'SJ',
	748 => 'SZ',
	752 => 'SE',
	756 => 'CH',
	760 => 'SY',
	762 => 'TJ',
	764 => 'TH',
	768 => 'TG',
	772 => 'TK',
	776 => 'TO',
	780 => 'TT',
	784 => 'AE',
	788 => 'TN',
	792 => 'TR',
	795 => 'TM',
	796 => 'TC',
	798 => 'TV',
	800 => 'UG',
	804 => 'UA',
	807 => 'MK',
	818 => 'EG',
	826 => 'GB',
	831 => 'GG',
	832 => 'JE',
	833 => 'IM',
	834 => 'TZ',
	840 => 'US',
	850 => 'VI',
	854 => 'BF',
	858 => 'UY',
	860 => 'UZ',
	862 => 'VE',
	876 => 'WF',
	882 => 'WS',
	887 => 'YE',
	894 => 'ZM'
);




$code2country = array(
	'AD' => 'Andorra',
	'AE' => 'United Arab Emirates',
	'AF' => 'Afghanistan',
	'AG' => 'Antigua and Barbuda',
	'AI' => 'Anguilla',
	'AL' => 'Albania',
	'AM' => 'Armenia',
	'AO' => 'Angola',
	'AQ' => 'Antarctica',
	'AR' => 'Argentina',
	'AS' => 'American Samoa',
	'AT' => 'Austria',
	'AU' => 'Australia',
	'AW' => 'Aruba',
	'AX' => 'Aland Islands',
	'AZ' => 'Azerbaijan',
	'BA' => 'Bosnia and Herzegovina',
	'BB' => 'Barbados',
	'BD' => 'Bangladesh',
	'BE' => 'Belgium',
	'BF' => 'Burkina Faso',
	'BG' => 'Bulgaria',
	'BH' => 'Bahrain',
	'BI' => 'Burundi',
	'BJ' => 'Benin',
	'BL' => 'Saint Bartelemey',
	'BM' => 'Bermuda',
	'BN' => 'Brunei Darussalam',
	'BO' => 'Bolivia',
	'BQ' => 'Bonaire, Saint Eustatius and Saba',
	'BR' => 'Brazil',
	'BS' => 'Bahamas',
	'BT' => 'Bhutan',
	'BV' => 'Bouvet Island',
	'BW' => 'Botswana',
	'BY' => 'Belarus',
	'BZ' => 'Belize',
	'CA' => 'Canada',
	'CC' => 'Cocos (Keeling) Islands',
	'CD' => 'Congo, The Democratic Republic of the',
	'CF' => 'Central African Republic',
	'CG' => 'Congo',
	'CH' => 'Switzerland',
	'CI' => 'Cote d\'Ivoire',
	'CK' => 'Cook Islands',
	'CL' => 'Chile',
	'CM' => 'Cameroon',
	'CN' => 'China',
	'CO' => 'Colombia',
	'CR' => 'Costa Rica',
	'CU' => 'Cuba',
	'CV' => 'Cape Verde',
	'CW' => 'Curacao',
	'CX' => 'Christmas Island',
	'CY' => 'Cyprus',
	'CZ' => 'Czech Republic',
	'DE' => 'Germany',
	'DJ' => 'Djibouti',
	'DK' => 'Denmark',
	'DM' => 'Dominica',
	'DO' => 'Dominican Republic',
	'DZ' => 'Algeria',
	'EC' => 'Ecuador',
	'EE' => 'Estonia',
	'EG' => 'Egypt',
	'EH' => 'Western Sahara',
	'ER' => 'Eritrea',
	'ES' => 'Spain',
	'ET' => 'Ethiopia',
	'FI' => 'Finland',
	'FJ' => 'Fiji',
	'FK' => 'Falkland Islands (Malvinas)',
	'FM' => 'Micronesia, Federated States of',
	'FO' => 'Faroe Islands',
	'FR' => 'France',
	'GA' => 'Gabon',
	'GB' => 'United Kingdom',
	'GD' => 'Grenada',
	'GE' => 'Georgia',
	'GF' => 'French Guiana',
	'GG' => 'Guernsey',
	'GH' => 'Ghana',
	'GI' => 'Gibraltar',
	'GL' => 'Greenland',
	'GM' => 'Gambia',
	'GN' => 'Guinea',
	'GP' => 'Guadeloupe',
	'GQ' => 'Equatorial Guinea',
	'GR' => 'Greece',
	'GS' => 'South Georgia and the South Sandwich Islands',
	'GT' => 'Guatemala',
	'GU' => 'Guam',
	'GW' => 'Guinea-Bissau',
	'GY' => 'Guyana',
	'HK' => 'Hong Kong',
	'HM' => 'Heard Island and McDonald Islands',
	'HN' => 'Honduras',
	'HR' => 'Croatia',
	'HT' => 'Haiti',
	'HU' => 'Hungary',
	'ID' => 'Indonesia',
	'IE' => 'Ireland',
	'IL' => 'Israel',
	'IM' => 'Isle of Man',
	'IN' => 'India',
	'IO' => 'British Indian Ocean Territory',
	'IQ' => 'Iraq',
	'IR' => 'Iran, Islamic Republic of',
	'IS' => 'Iceland',
	'IT' => 'Italy',
	'JE' => 'Jersey',
	'JM' => 'Jamaica',
	'JO' => 'Jordan',
	'JP' => 'Japan',
	'KE' => 'Kenya',
	'KG' => 'Kyrgyzstan',
	'KH' => 'Cambodia',
	'KI' => 'Kiribati',
	'KM' => 'Comoros',
	'KN' => 'Saint Kitts and Nevis',
	'KP' => 'Korea, Democratic People\'s Republic of',
	'KR' => 'Korea, Republic of',
	'KW' => 'Kuwait',
	'KY' => 'Cayman Islands',
	'KZ' => 'Kazakhstan',
	'LA' => 'Lao People\'s Democratic Republic',
	'LB' => 'Lebanon',
	'LC' => 'Saint Lucia',
	'LI' => 'Liechtenstein',
	'LK' => 'Sri Lanka',
	'LR' => 'Liberia',
	'LS' => 'Lesotho',
	'LT' => 'Lithuania',
	'LU' => 'Luxembourg',
	'LV' => 'Latvia',
	'LY' => 'Libyan Arab Jamahiriya',
	'MA' => 'Morocco',
	'MC' => 'Monaco',
	'MD' => 'Moldova, Republic of',
	'ME' => 'Montenegro',
	'MF' => 'Saint Martin',
	'MG' => 'Madagascar',
	'MH' => 'Marshall Islands',
	'MK' => 'Macedonia',
	'ML' => 'Mali',
	'MM' => 'Myanmar',
	'MN' => 'Mongolia',
	'MO' => 'Macao',
	'MP' => 'Northern Mariana Islands',
	'MQ' => 'Martinique',
	'MR' => 'Mauritania',
	'MS' => 'Montserrat',
	'MT' => 'Malta',
	'MU' => 'Mauritius',
	'MV' => 'Maldives',
	'MW' => 'Malawi',
	'MX' => 'Mexico',
	'MY' => 'Malaysia',
	'MZ' => 'Mozambique',
	'NA' => 'Namibia',
	'NC' => 'New Caledonia',
	'NE' => 'Niger',
	'NF' => 'Norfolk Island',
	'NG' => 'Nigeria',
	'NI' => 'Nicaragua',
	'NL' => 'Netherlands',
	'NO' => 'Norway',
	'NP' => 'Nepal',
	'NR' => 'Nauru',
	'NU' => 'Niue',
	'NZ' => 'New Zealand',
	'OM' => 'Oman',
	'PA' => 'Panama',
	'PE' => 'Peru',
	'PF' => 'French Polynesia',
	'PG' => 'Papua New Guinea',
	'PH' => 'Philippines',
	'PK' => 'Pakistan',
	'PL' => 'Poland',
	'PM' => 'Saint Pierre and Miquelon',
	'PN' => 'Pitcairn',
	'PR' => 'Puerto Rico',
	'PS' => 'Palestinian Territory',
	'PT' => 'Portugal',
	'PW' => 'Palau',
	'PY' => 'Paraguay',
	'QA' => 'Qatar',
	'RE' => 'Reunion',
	'RO' => 'Romania',
	'RS' => 'Serbia',
	'RU' => 'Russian Federation',
	'RW' => 'Rwanda',
	'SA' => 'Saudi Arabia',
	'SB' => 'Solomon Islands',
	'SC' => 'Seychelles',
	'SD' => 'Sudan',
	'SE' => 'Sweden',
	'SG' => 'Singapore',
	'SH' => 'Saint Helena',
	'SI' => 'Slovenia',
	'SJ' => 'Svalbard and Jan Mayen',
	'SK' => 'Slovakia',
	'SL' => 'Sierra Leone',
	'SM' => 'San Marino',
	'SN' => 'Senegal',
	'SO' => 'Somalia',
	'SR' => 'Suriname',
	'SS' => 'South Sudan',
	'ST' => 'Sao Tome and Principe',
	'SV' => 'El Salvador',
	'SX' => 'Sint Maarten',
	'SY' => 'Syrian Arab Republic',
	'SZ' => 'Swaziland',
	'TC' => 'Turks and Caicos Islands',
	'TD' => 'Chad',
	'TF' => 'French Southern Territories',
	'TG' => 'Togo',
	'TH' => 'Thailand',
	'TJ' => 'Tajikistan',
	'TK' => 'Tokelau',
	'TL' => 'Timor-Leste',
	'TM' => 'Turkmenistan',
	'TN' => 'Tunisia',
	'TO' => 'Tonga',
	'TR' => 'Turkey',
	'TT' => 'Trinidad and Tobago',
	'TV' => 'Tuvalu',
	'TW' => 'Taiwan',
	'TZ' => 'Tanzania, United Republic of',
	'UA' => 'Ukraine',
	'UG' => 'Uganda',
	'UM' => 'United States Minor Outlying Islands',
	'US' => 'United States',
	'UY' => 'Uruguay',
	'UZ' => 'Uzbekistan',
	'VA' => 'Holy See (Vatican City State)',
	'VC' => 'Saint Vincent and the Grenadines',
	'VE' => 'Venezuela',
	'VG' => 'Virgin Islands, British',
	'VI' => 'Virgin Islands, U.S.',
	'VN' => 'Vietnam',
	'VU' => 'Vanuatu',
	'WF' => 'Wallis and Futuna',
	'WS' => 'Samoa',
	'YE' => 'Yemen',
	'YT' => 'Mayotte',
	'ZA' => 'South Africa',
	'ZM' => 'Zambia',
	'ZW' => 'Zimbabwe'
);