<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | json.php                                                               |
//  +------------------------------------------------------------------------+
require_once('include/initialize.inc.php');

$action	= @$_REQUEST['action'];

if		($action == 'suggestAlbumArtist')	suggestAlbumArtist();
elseif	($action == 'suggestTrackArtist')	suggestTrackArtist();
elseif	($action == 'suggestTrackTitle')	suggestTrackTitle();
elseif	($action == 'loginStage1')			loginStage1();
else	message(__FILE__, __LINE__, 'error', '[b]Unsupported input value for[/b][br]action');




//  +------------------------------------------------------------------------+
//  | Suggest album artist                                                   |
//  +------------------------------------------------------------------------+
function suggestAlbumArtist() {
	global $cfg, $db;
	authenticate('access_media', true);
	$artist = @$_GET['artist'];

	if ($artist == '')
		exit('[]');

	$query = mysqli_query($db, 'SELECT artist_alphabetic
		FROM album
		WHERE artist_alphabetic LIKE "%' . mysqli_real_escape_like($db, $artist) . '%"
		OR artist LIKE "%' . mysqli_real_escape_like($db, $artist) . '%"
		OR artist SOUNDS LIKE "' . mysqli_real_escape_string($db, $artist) . '"
		GROUP BY artist_alphabetic
		ORDER BY artist_alphabetic
		LIMIT ' . (int) $cfg['autosuggest_limit']);

	$data = array();
	while ($album = mysqli_fetch_assoc($query))
		$data[] = (string) $album['artist_alphabetic'];

	echo safe_json_encode($data);
}




//  +------------------------------------------------------------------------+
//  | Suggest track artist                                                   |
//  +------------------------------------------------------------------------+
function suggestTrackArtist() {
	global $cfg, $db;
	authenticate('access_media', true);
	$artist = @$_GET['artist'];

	if ($artist == '')
		exit('[]');

	$query = mysqli_query($db, 'SELECT artist
		FROM track
		WHERE artist LIKE "%' . mysqli_real_escape_like($db, $artist) . '%"
		OR artist SOUNDS LIKE "' . mysqli_real_escape_string($db, $artist) . '"
		GROUP BY artist
		ORDER BY artist LIMIT ' . (int) $cfg['autosuggest_limit']);

	$data = array();
	while ($album = mysqli_fetch_assoc($query))
		$data[] = (string) $album['artist'];

	echo safe_json_encode($data);
}




//  +------------------------------------------------------------------------+
//  | Suggest track title                                                    |
//  +------------------------------------------------------------------------+
function suggestTrackTitle() {
	global $cfg, $db;
	authenticate('access_media', true);
	$title = @$_GET['title'];

	if ($title == '')
			exit('[]');

	$query = mysqli_query($db, 'SELECT title
		FROM track
		WHERE title LIKE "%' . mysqli_real_escape_like($db, $title) . '%"
		OR title SOUNDS LIKE "' . mysqli_real_escape_string($db, $title) . '"
		GROUP BY title
		ORDER BY title
		LIMIT ' . (int) $cfg['autosuggest_limit']);

	$data = array();
	while ($track = mysqli_fetch_assoc($query))
		$data[] = (string) $track['title'];

	echo safe_json_encode($data);
}




//  +------------------------------------------------------------------------+
//  | Login stage 1                                                          |
//  +------------------------------------------------------------------------+
function loginStage1() {
	global $cfg, $db;
	header('Expires: Mon, 9 Oct 2000 18:00:00 GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Content-type: application/json');

	$username		= @$_POST['username'];
	$lock_ip		= @$_POST['lock_ip'] ? 1 : 0;
	$sid			= @$_COOKIE['netjukebox_sid'];
	$sign			= randomBase64url();
	$session_salt	= randomBase64url();

	$query = mysqli_query($db, 'SELECT ' . (string) round(microtime(true) * 1000) . ' - pre_login_time AS previous_login_attempt FROM session WHERE ip = "' . mysqli_real_escape_string($db, $_SERVER['REMOTE_ADDR']) . '" ORDER BY pre_login_time DESC LIMIT 1');
	$ip = mysqli_fetch_assoc($query);

	// Update current session
	mysqli_query($db, 'UPDATE session SET
		logged_in			= 0,
		ip					= "' . mysqli_real_escape_string($db, $_SERVER['REMOTE_ADDR']) . '",
		user_agent			= "' . mysqli_real_escape_string($db, $_SERVER['HTTP_USER_AGENT']) . '",
		sign				= "' . mysqli_real_escape_string($db, $sign) . '",
		salt				= "' . mysqli_real_escape_string($db, $session_salt) . '",
		scrypt_options		= "' . mysqli_real_escape_string($db, NJB_SCRYPT_OPTIONS) . '",
		pre_login_time		= ' . (string) round(microtime(true) * 1000) . ',
		lock_ip				= ' . (int) $lock_ip . '
		WHERE sid			= BINARY "' . mysqli_real_escape_string($db, $sid) . '"');
	if (mysqli_affected_rows($db) == 0) {
		// Create new session
		$sid = randomSid();

		mysqli_query($db, 'INSERT INTO session (logged_in, create_time, ip, user_agent, sid, sign, salt, scrypt_options, pre_login_time, lock_ip) VALUES (
			0,
			' . (int) time() . ',
			"' . mysqli_real_escape_string($db, $_SERVER['REMOTE_ADDR']) . '",
			"' . mysqli_real_escape_string($db, $_SERVER['HTTP_USER_AGENT']) . '",
			"' . mysqli_real_escape_string($db, $sid) . '",
			"' . mysqli_real_escape_string($db, $sign) . '",
			"' . mysqli_real_escape_string($db, $session_salt) . '",
			"' . mysqli_real_escape_string($db, NJB_SCRYPT_OPTIONS) . '",
			' . (string) round(microtime(true) * 1000) . ',
			' . (int) $lock_ip . ')');

		setcookie('netjukebox_sid', $sid, time() + 31536000, null, null, null, true);
	}


	// Brute force and parallel login protection.
	// Login will fail with wrong sign.
	if ($ip['previous_login_attempt'] && $ip['previous_login_attempt'] < 2000)
		$sign = randomBase64url();


	$query = mysqli_query($db, 'SELECT salt, scrypt_options FROM user WHERE username = "' . mysqli_real_escape_string($db, $username) . '"');
	$user = mysqli_fetch_assoc($query);


	// Always calculate fake salt to prevent script execution time differences (anonymous_user salt doesn't change at login)
	$query = mysqli_query($db, 'SELECT SHA1(GROUP_CONCAT(salt SEPARATOR "")) AS sha1_concat_salt FROM user ORDER BY user_id');
	$fake = mysqli_fetch_assoc($query);

	$fake_salt = hash_hmac('sha256', strtolower($username) . $fake['sha1_concat_salt'], $cfg['server_salt'], true);
	$fake_salt = substr(base64url_encode($fake_salt), 0, 40);

	if ($user['salt'] == '') {
		$user['salt'] = $fake_salt;
		$user['scrypt_options'] = NJB_SCRYPT_OPTIONS;
	}


	$data = array();
	$data['user_salt']				= $user['salt'];
	$data['user_scrypt_options']	= ($user['scrypt_options']) ? json_decode($user['scrypt_options'], true) : '';
	$data['session_salt']			= $session_salt;
	$data['session_scrypt_options']	= json_decode(NJB_SCRYPT_OPTIONS, true);
	$data['sign']					= $sign;

	echo safe_json_encode($data);
}
