<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | playlist.php                                                           |
//  +------------------------------------------------------------------------+
require_once('include/initialize.inc.php');
$cfg['menu'] = 'playlist';

authenticate('access_play');
require_once('include/play.inc.php');


// Navigator
$nav			= array();
$nav['name'][]	= 'Playlist';
$nav['url'][]	= null;
$nav['class'][]	= 'nav';

if ($cfg['switch_play_mode']) {
	$nav['name'][]	= 'Play mode';
	$nav['class'][]	= 'nav';
	$nav['url'][]	= ($cfg['html_audio_url']) ? $cfg['html_audio_url'] : 'stream.php?action=audio';

	$cfg['play_mode'] = true;
	mysqli_query($db, 'UPDATE session
		SET play_mode	= ' . (int) $cfg['play_mode'] . '
		WHERE sid		= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
}
navPlayerProfile();

require_once('include/header.inc.php');


if ($cfg['player_type'] == NJB_HTTPQ) {
	$hash			= httpq('gethash');
	$listpos		= httpq('getlistpos');
	$file			= httpq('getplaylistfilelist', 'delim=*');
	$file			= str_replace('\\', '/', $file);
	$file			= explode('*', $file);
	$listlength		= (empty($file[0])) ? 0 : count($file);
	$volume			= true;
	$max_volume		= 255;
	$default_image	= $cfg['img'] . 'large_httpq.png';

	// Get relative directory based on $cfg['media_share']
	foreach ($file as $i => $value)	{
		if (strtolower(substr($file[$i], 0, strlen($cfg['media_share']))) == strtolower($cfg['media_share']))
			$file[$i] = substr($file[$i], strlen($cfg['media_share']));
	}
}
elseif ($cfg['player_type'] == NJB_MPD)	{
	$status 		= mpd('status');
	$listpos		= isset($status['song']) ? $status['song'] : 0;
	$file			= mpd('playlist');
	$hash			= md5(implode('<seperation>', $file));
	$listlength		= $status['playlistlength'];
	$volume			= (isset($status['volume']) == false || $status['volume'] == -1) ? false : true;
	$max_volume		= 100;
	$default_image	= $cfg['img'] . 'large_mpd.png';
}
elseif ($cfg['player_type'] == NJB_VLC)
	message(__FILE__, __LINE__, 'warning', '[b]videoLAN playlist not supported yet[/b]');
else
	message(__FILE__, __LINE__, 'error', '[b]Player not supported[/b]');


$featuring = false;
for ($i = 0; $i < $listlength && !$featuring; $i++) {
	$query = mysqli_query($db, 'SELECT featuring FROM track WHERE featuring != "" AND relative_file = "' . mysqli_real_escape_string($db, $file[$i]) . '"');
	if (mysqli_fetch_row($query)) $featuring = true;
}
?>
<div id="playlist_container">
	<div id="playlist_cover"><img src="lib/image/white.png" alt=""></div>
	<ul id="playlist_text">
		<li class="odd"><span class="description">Title:</span><span id="title"></span></li>
		<li class="even"><span class="description">Artist:</span><span id="artist"></span></li>
		<li class="odd"><span class="description">Album:</span><span id="album"></span></li>
		<li class="even"><span class="description">By:</span><span id="by"></span></li>
	</ul>
</div>
<ul id="playlist_control">
	<li id="shuffle" class="shuffle off onclick" onclick="ajaxRequest('play.php?action=toggleShuffle&amp;menu=playlist',updateShuffle);">shuffle</li>
	<li id="repeat" class="repeat off onclick" onclick="ajaxRequest('play.php?action=toggleRepeat&amp;menu=playlist',updateRepeat);">repeat</li>
<?php
if ($cfg['player_type'] == NJB_MPD && version_compare($cfg['mpd_version'], '0.16.0', '>=')) { ?>
	<li id="gain" class="gain off onclick" onclick="ajaxRequest('play.php?action=loopGain&amp;menu=playlist',updateGain);">gain</li>
<?php
} ?>
	<li class="previous onclick" onclick="ajaxRequest('play.php?action=prev&amp;menu=playlist',updateListpos);">previous</li>
	<li id="play" class="play off onclick" onclick="ajaxRequest('play.php?action=play&amp;menu=playlist',updateIsplaying);">play</li>
	<li id="pause" class="pause off onclick" onclick="ajaxRequest('play.php?action=pause&amp;menu=playlist',updateIsplaying);">pause</li>
	<li class="next onclick" onclick="ajaxRequest('play.php?action=next&amp;menu=playlist',updateListpos);">next</li>
	<li class="stop onclick" onclick="ajaxRequest('play.php?action=stop&amp;menu=playlist',updateIsplaying);">stop</li>
	<li class="progress onclick"><div id="time_input" class="input" onclick="ajaxRequest('play.php?action=seekImageMap&amp;dx=' + this.clientWidth + '&amp;x=' + getRelativeX(event, this) + '&amp;menu=playlist',updatePlaytime);"><div id="time_bar" class="on"></div></div></li>
	<li id="time" class="display"></li>
<?php
if ($volume) { ?>
	<li class="progress onclick"><div id="volume_input" class="input" onclick="ajaxRequest('play.php?action=volumeImageMap&amp;dx=' + this.clientWidth + '&amp;x=' + getRelativeX(event, this) + '&amp;menu=playlist',updateVolume);"><div id="volume_bar" class="on"></div></div></li>
	<li id="volume" class="display onclick" onclick="ajaxRequest('play.php?action=toggleMute&amp;menu=playlist',updateVolume);"></li>
<?php
} ?>
</ul>
<table class="border">
<tr class="header">
	<td class="space"></td>
	<td>Title</td>
	<td class="textspace"></td>
	<td>Artist</td>
	<td class="textspace"></td>
	<td><?php if ($featuring) echo'Featuring'; ?></td><!-- optional featuring -->
	<td<?php if ($featuring) echo' class="textspace"'; ?>></td>
	<td style="text-align:right">Time</td>
	<td<?php if ($cfg['access_play']) echo' class="space"'; ?>></td>
	<td></td><!-- optional delete -->
	<td class="space"></td>
</tr>
<?php
$playtime = array();
$track_id = array();
for ($i=0; $i < $listlength; $i++) {
	$query = mysqli_query($db, 'SELECT title, artist, featuring, miliseconds, track_id FROM track WHERE relative_file = "' . mysqli_real_escape_string($db, $file[$i]) . '"');
	$track = mysqli_fetch_assoc($query);
	$playtime[] = (int) $track['miliseconds'];
	$track_id[] = (string) $track['track_id'];
	if (!isset($track['artist'])) {
		$track['title'] = $file[$i];
		$track['artist'] = 'Unknown';
	}
?>
<tr class="<?php if ($i == $listpos) echo 'select'; else echo ($i & 1) ? 'even mouseover' : 'odd mouseover'; ?>" id="track<?php echo $i; ?>">
	<td></td>
	<td><a href="javascript:ajaxRequest('play.php?action=playIndex&amp;index=<?php echo $i; ?>&amp;menu=playlist',updateListpos);" title="Play"><img src="<?php echo $cfg['img']; ?>small_play.png" alt="" class="small space"><?php echo html($track['title']); ?></a></td>
	<td></td>
	<td><?php echo artisLink($track['artist']); ?></td>
	<td></td>
	<td><?php if (isset($track['featuring'])) echo html($track['featuring']); ?></td>
	<td></td>
	<td style="text-align:right"><?php echo (isset($track['miliseconds'])) ? formattedTime($track['miliseconds']) : '0:00'; ?></td>
	<td></td>
	<td><a href="javascript:ajaxRequest('play.php?action=deleteIndex&amp;index=<?php echo $i; ?>&amp;menu=playlist');" title="Delete"><img src="<?php echo $cfg['img']; ?>small_delete.png" alt="" class="small"></a></td>
	<td></td>
</tr>
<?php
}
?>
</table>
<script>
var track_id				= <?php echo safe_json_encode($track_id); ?>;
var playtime				= <?php echo safe_json_encode($playtime); ?>;
var previous_hash			= '<?php echo $hash; ?>';
var previous_listpos		= -1; // force update
var previous_miliseconds	= -1;
var previous_isplaying		= -1;
var previous_repeat			= -1;
var previous_shuffle		= -1;
var previous_gain			= -1;
var previous_volume			= -1;
var timer_id				= 0;


function initialize() {
	ajaxRequest('play.php?action=trackInfo&track_id=' + track_id[<?php echo $listpos; ?>] + '&menu=playlist',updateTrack);
	ajaxRequest('play.php?action=playlistStatus&menu=playlist',updateStatus);
}


function timer() {
	clearTimeout(timer_id);
	timer_id = setTimeout(function() { ajaxRequest('play.php?action=playlistStatus&menu=playlist',updateStatus); }, 1000);
}


function updateStatus(data) {
	// data.hash, data.miliseconds, data.listpos, data.volume
	// data.isplaying, data.repeat, data.shuffle, data.gain
	if (previous_hash != data.hash) {
		location.href = "<?php echo NJB_HOME_URL ?>playlist.php";
	}
	data.max = playtime[data.listpos];
	updateListpos(data.listpos);
	updatePlaytime(data);
	updateRepeat(data.repeat);
	updateShuffle(data.shuffle);
	updateIsplaying(data.isplaying);
	updateGain(data.gain);
<?php echo ($volume) ? "\t" . 'updateVolume(data.volume);' . "\n" : ''; ?>
}


function updateListpos(listpos) {
	if (previous_listpos != listpos) {
		if (previous_listpos != -1)
			document.getElementById('track' + previous_listpos).className = (previous_listpos & 1) ? 'even mouseover' : 'odd mouseover';
		document.getElementById('track' + listpos).className = 'select';
		document.getElementById('time').textContent = formattedTime(0);
		document.getElementById('time_bar').style.width = 0;
		if (playtime[listpos])	document.getElementById('time_input').parentNode.classList.add('onclick');
		else					document.getElementById('time_input').parentNode.classList.remove('onclick');
		ajaxRequest('play.php?action=trackInfo&track_id=' + track_id[listpos] + '&menu=playlist',updateTrack);
		previous_miliseconds = 0;
		previous_listpos = listpos;
	}
}


function updatePlaytime(data) {
	// data.miliseconds, data.max
	var dx = document.getElementById('time_input').clientWidth;
	if (previous_miliseconds != data.miliseconds) {
		document.getElementById('time').textContent = formattedTime(data.miliseconds);
		var width = 0;
		if (data.max > 0)
			width = Math.round(data.miliseconds / data.max * dx);
		if (width > dx)
			width = dx;
		document.getElementById('time_bar').style.width = width + 'px';
		previous_miliseconds = data.miliseconds;
	}
}


function updateVolume(volume) {
	var dx = document.getElementById('volume_input').clientWidth;
	if (previous_volume != volume && volume >= 0) {
		// Volume
		var volume_percentage	= Math.round(100 * volume / <?php echo $max_volume; ?>);
		var width				= Math.round(dx * volume / <?php echo $max_volume; ?>);
		document.getElementById('volume').textContent = volume_percentage + '%';
		document.getElementById('volume_bar').className = 'on onclick';
		document.getElementById('volume_bar').style.width = width + 'px';
		previous_volume = volume;
	}
	if (previous_volume != volume && volume < 0) {
		// Mute volume
		var mute_volume = -1 * volume;
		var volume_percentage	= Math.round(100 * mute_volume / <?php echo $max_volume; ?>);
		var width				= Math.round(dx * mute_volume / <?php echo $max_volume; ?>);
		document.getElementById('volume').textContent = 'mute';
		document.getElementById('volume_bar').className = 'off onclick';
		document.getElementById('volume_bar').style.width = width + 'px';
		previous_volume = volume;
	}
}


function updateIsplaying(isplaying) {
	if (previous_isplaying != isplaying) {
		if (isplaying == 0) {
			// stop
			document.getElementById('play').className = 'play off onclick';
			document.getElementById('pause').className = 'pause off onclick';
			document.getElementById('time').textContent = formattedTime(0);
			document.getElementById('time_bar').style.width = 0;
			previous_miliseconds = 0;
		}
		else if (isplaying == 1) {
			// play
			document.getElementById('play').className = 'play on onclick';
			document.getElementById('pause').className = 'pause off onclick';
		}
		else if (isplaying == 3) {
			// pause
			document.getElementById('play').className = 'play off onclick';
			document.getElementById('pause').className = 'pause on onclick';
		}
		previous_isplaying = isplaying
	}
}


function updateRepeat(repeat) {
	if (previous_repeat != repeat) {
		if (repeat == 0) document.getElementById('repeat').className = 'repeat off onclick';
		if (repeat == 1) document.getElementById('repeat').className = 'repeat on onclick';
		previous_repeat = repeat;
	}
}


function updateShuffle(shuffle) {
	if (previous_shuffle != shuffle) {
		if (shuffle == 0) document.getElementById('shuffle').className = 'shuffle off onclick';
		if (shuffle == 1) document.getElementById('shuffle').className = 'shuffle on onclick';
		previous_shuffle = shuffle;
	}
}


function updateGain(gain) {
	if (previous_gain != gain) {
		if (gain == 'off')		{ document.getElementById('gain').className = 'gain off onclick'; document.getElementById('gain').textContent = 'gain'; }
		if (gain == 'album')	{ document.getElementById('gain').className = 'gain album onclick'; document.getElementById('gain').textContent = 'album'; }
		if (gain == 'track')	{ document.getElementById('gain').className = 'gain track onclick'; document.getElementById('gain').textContent = 'track'; }
		if (gain == 'fade')		{ document.getElementById('gain').className = 'gain fade onclick';	document.getElementById('gain').textContent = 'fade'; }
		previous_gain = gain;
	}
}


function updateTrack(data) {
	// data.artist, data.title, data.album, data.by, data.album_id, data.image_id
	document.getElementById('artist').textContent = data.artist;
	document.getElementById('title').textContent = data.title;
	document.getElementById('album').textContent = data.album;
	document.getElementById('by').textContent = data.by;

	if (data.album_id) {
		document.getElementById('playlist_cover').innerHTML = '<a href="" title="Jump to album"><img src="" alt=""></a>';
		document.getElementById('playlist_cover').firstChild.href = 'index.php?action=view3&album_id=' + data.album_id;
		document.getElementById('playlist_cover').firstChild.firstChild.src = 'image.php?image_id=' + data.image_id;
		tooltip.init();
	}
	else {
		document.getElementById('playlist_cover').innerHTML = '<img src="" alt="">';
		document.getElementById('playlist_cover').firstChild.src = '<?php echo $default_image; ?>';
	}
}
</script>
<?php
require_once('include/footer.inc.php');
