<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | stream.php                                                             |
//  +------------------------------------------------------------------------+
require_once('include/initialize.inc.php');
require_once('include/stream.inc.php');
require_once('include/cache.inc.php');

$action		= @$_GET['action'];
$album_id	= @$_GET['album_id'];

if		($action == 'audio')		audio();
elseif	($action == 'm3u')			m3u();
elseif	($action == 'stream')		stream();
elseif	($action == 'shareAlbum')	shareAlbum($album_id);
else	message(__FILE__, __LINE__, 'error', '[b]Unsupported input value for[/b][br]action');




//  +------------------------------------------------------------------------+
//  | Audio                                                                  |
//  +------------------------------------------------------------------------+
function audio() {
	global $cfg, $db;

	$cfg['menu'] 		= 'playlist';
	$sid				= @$_GET['sid'];
	$list 				= listAuthenticateStream();
	$canplay_lossy		= explode(',', @$_COOKIE['netjukebox_canplay_lossy']);
	$canplay_lossless	= explode(',', @$_COOKIE['netjukebox_canplay_lossless']);
	$canplay			= array_merge($canplay_lossy, $canplay_lossless);


	// Reload page if session cookie is not set
	if (isset($_COOKIE['netjukebox_canplay_lossy']) == false) {
		require_once('include/header.inc.php');
		echo '<script>function initialize() { setTimeout(function() { location.reload(); }, 250); }</script>';
		require_once('include/footer.inc.php');
		exit();
	}


	if ($sid) {
		// m3u share stream
		$m3u = NJB_HOME_URL;
		$m3u .= 'stream.php?action=m3u';
		$m3u .= '&sid=' . rawurlencode($sid);
	}
	else {
		// m3u
		$stream_id				= @$_GET['stream_id'];
		$album_id				= @$_GET['album_id'];
		$track_id				= @$_GET['track_id'];
		$favorite_id			= @$_GET['favorite_id'];
		$random					= @$_GET['random'];

		$data = array();
		$data['action']			= 'm3u';
		$data['stream_id']		= $stream_id;

		if ($album_id)			$data['album_id']		= $album_id;
		elseif ($track_id)		$data['track_id']		= $track_id;
		elseif ($favorite_id)	$data['favorite_id']	= $favorite_id;
		elseif ($random)		$data['random']			= $random;
		ksort($data);

		$m3u = NJB_HOME_URL;
		$m3u .= 'stream.php?';
		$m3u .=	http_build_query($data);
		$m3u .= '&short_sid=' . substr($cfg['sid'], 0, 8);
		$m3u .= '&hash=' . hash_hmac('sha1', $cfg['sid'] . implode('', $data), $cfg['server_salt']);
	}


	// Manual or auto fallback to m3u playlist
	if ($cfg['html_audio_lossy'] == false || $list['m3u'] == true || count(array_diff($list['extension'], $canplay)) > 0)
		header('Location: ' . $m3u);


	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Playlist';
	$nav['url'][]	= null;
	$nav['class'][]	= 'nav';

	if (isset($cfg['switch_play_mode']) && $cfg['switch_play_mode']) {
		$nav['name'][]	= 'Stream mode';
		$nav['class'][]	= 'nav';
		$nav['url'][]	= 'playlist.php';

		$cfg['play_mode'] = false;
		mysqli_query($db, 'UPDATE session
			SET play_mode	= ' . (int) $cfg['play_mode'] . '
			WHERE sid		= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
	}
	require_once('include/header.inc.php');
	$featuring = (array_filter($list['featuring']) === Array()) ? false : true;
?>
<div id="playlist_container">
	<div id="playlist_cover"><img src="lib/image/white.png" alt=""></div>
	<ul id="playlist_text">
		<li class="odd"><span class="description">Title:</span><span id="title"></span></li>
		<li class="even"><span class="description">Artist:</span><span id="artist"></span></li>
		<li class="odd"><span class="description">Album:</span><span id="album"></span></li>
		<li class="even"><span class="description">By:</span><span id="by"></span></li>
	</ul>
</div>
<ul id="playlist_control">
	<li class="previous onclick" onclick="previous();">previous</li>
	<li id="play" class="play off onclick" onclick="stream();">play</li>
	<li id="pause" class="pause off onclick" onclick="pause();">pause</li>
	<li class="next onclick" onclick="next();">next</li>
	<li class="stop onclick" onclick="stop();">stop</li>
	<li class="progress onclick"><div id="time_input" class="input" onclick="seek(getRelativeX(event, this));"><div id="time_bar" class="on"></div></div></li>
	<li id="time" class="display"></li>
</ul>
<audio id="audio_one_id"></audio>
<audio id="audio_two_id"></audio>
<table class="border">
<tr class="header">
	<td class="space"></td>
	<td>Title</td>
	<td class="textspace"></td>
	<td>Artist</td>
	<td class="textspace"></td>
	<td><?php if ($featuring) echo 'Featuring'; ?></td><!-- optional featuring -->
	<td<?php if ($featuring) echo ' class="textspace"'; ?>></td>
	<td style="text-align:right">Time</td>
	<td class="space"></td>
</tr><?php
	for ($i = 0; $i < count($list['url']); $i++) { ?>
<tr class="<?php echo ($i & 1) ? 'even mouseover' : 'odd mouseover'; ?>" id="track<?php echo $i; ?>">
	<td></td>
	<td><a href="javascript:streamTrack(<?php echo $i; ?>);" title="<?php echo html($list['info'][$i]); ?>"><img src="<?php echo $cfg['img']; ?>small_stream.png" alt="" class="small space"><?php echo html($list['title'][$i]); ?></a></td>
	<td></td>
	<td><?php echo artisLink($list['artist'][$i]); ?></td>
	<td></td>
	<td><?php echo html($list['featuring'][$i]); ?></td>
	<td></td>
	<td style="text-align:right"><?php echo formattedTime($list['miliseconds'][$i]); ?></td>
	<td></td>
</tr>
<?php
	} ?>
</table>
<script>
var url						= <?php echo safe_json_encode($list['url']); ?>;
var track_id				= <?php echo safe_json_encode($list['track_id']); ?>;
var playtime				= <?php echo safe_json_encode($list['miliseconds']); ?>;
var seekable				= <?php echo safe_json_encode($list['seekable']); ?>;
var dummy					= 'lib/media/silent.mp3';
var audio_one				= document.getElementById('audio_one_id');
var audio_two				= document.getElementById('audio_two_id');
var audio_player			= audio_one;
var audio_buffer			= audio_two;
var timer_id				= 0;
var listpos					= 0;
var len 					= url.length - 1;
var previous_listpos		= -1; // force update
var previous_miliseconds	= -1;


function initialize() {
	audio_player.volume = 1;
	audio_buffer.volume = 1;
	audio_player.preload = 'auto';
	audio_buffer.preload = 'auto';
	restorePlaystate();
}


function storePlaystate() {
	var playstate = {
		url:			url[listpos],
		listpos:		listpos,
		paused:			audio_player.paused,
		currentTime:	audio_player.currentTime
	}
	localStorage.setItem('netjukebox_playstate', JSON.stringify(playstate));
}


function restorePlaystate() {
	var playstate;
	if ((playstate = JSON.parse(localStorage.getItem('netjukebox_playstate'))) && len >= 0 && playstate.listpos <= len && playstate.url == url[playstate.listpos]) {
		listpos = playstate.listpos;
		audio_player = (listpos & 1) ? audio_two : audio_one;
		audio_buffer = (listpos & 1) ? audio_one : audio_two;

		audio_buffer.setAttribute('src', dummy);
		audio_player.setAttribute('src', url[listpos]);

		var restore_seek = false;
		audio_player.oncanplay = function() {
			if (restore_seek) return;
			if (seekable[listpos])
				audio_player.currentTime = playstate.currentTime;
			updatePlaytime();
			restore_seek = true;
		}

		if (seekable[listpos])	document.getElementById('time_input').parentNode.classList.add('onclick');
		else					document.getElementById('time_input').parentNode.classList.remove('onclick');

		if (playstate.paused && playstate.currentTime == 0) {
			audio_player.pause();
			document.getElementById('pause').className = 'pause off onclick';
			document.getElementById('play').className = 'play off onclick';
		}
		else if (playstate.paused) {
			audio_player.pause();
			document.getElementById('pause').className = 'pause on onclick';
			document.getElementById('play').className = 'play off onclick';
		}
		else {
			audio_player.play();
			document.getElementById('pause').className = 'pause off onclick';
			document.getElementById('play').className = 'play on onclick';
		}
		updateListpos();
	}
	else if (len >= 0)
		stream();
	else
		document.getElementById('playlist_cover').firstChild.src = '<?php echo $cfg['img']; ?>large_html5audio.png';
}


function stream() {
	audio_player = (listpos & 1) ? audio_two : audio_one;
	audio_buffer = (listpos & 1) ? audio_one : audio_two;

	audio_buffer.setAttribute('src', dummy);
	if (audio_player.src != url[listpos])
		audio_player.setAttribute('src', url[listpos]);

	if (audio_player.currentTime > 0)
		audio_player.currentTime = 0;
	audio_player.play();

	if (seekable[listpos])	document.getElementById('time_input').parentNode.classList.add('onclick');
	else					document.getElementById('time_input').parentNode.classList.remove('onclick');

	document.getElementById('pause').className = 'pause off onclick';
	document.getElementById('play').className = 'play on onclick';
	updateListpos();
}


function updateListpos() {
	clearTimeout(timer_id);
	timer_id = setTimeout(updateListpos, 1000);

	if (previous_listpos != listpos) {
		if (previous_listpos != -1)
			document.getElementById('track' + previous_listpos).className = (previous_listpos & 1) ? 'even mouseover' : 'odd mouseover';
		document.getElementById('track' + listpos).className = 'select';
		ajaxRequest('play.php?action=trackInfo&track_id=' + track_id[listpos] + '<?php if ($sid) echo '&sid=' . $sid; ?>',updateTrack);
		previous_listpos = listpos;
	}
	updatePlaytime();
	storePlaystate();
}


function updatePlaytime() {
	var dx = document.getElementById('time_input').clientWidth;
	var miliseconds = audio_player.currentTime * 1000;
	var buffer = listpos + 1;
	if (miliseconds > (3/4 * playtime[listpos]) && audio_buffer.src != url[buffer] && listpos < len) {
		audio_buffer.setAttribute('src', url[buffer]);
		audio_buffer.load();
	}
	if (previous_miliseconds != miliseconds) {
		document.getElementById('time').textContent = formattedTime(miliseconds);
		var width = 0;
		if (playtime[listpos] > 0)
			width = Math.round(dx * miliseconds / playtime[listpos]);
		if (width > dx)
			width = dx;
		document.getElementById('time_bar').style.width = width + 'px';
		previous_miliseconds = miliseconds;
	}
}


function updateTrack(data) {
	// data.artist, data.title, data.album, data.by, data.album_id, data.image_id
	document.getElementById('artist').textContent = data.artist;
	document.getElementById('title').textContent = data.title;
	document.getElementById('album').textContent = data.album;
	document.getElementById('by').textContent = data.by;

	if (data.album_id) {
		document.getElementById('playlist_cover').innerHTML = '<a href="" title="Jump to album"><img src="" alt=""></a>';
		document.getElementById('playlist_cover').firstChild.href = 'index.php?action=view3&album_id=' + data.album_id;
		document.getElementById('playlist_cover').firstChild.firstChild.src = 'image.php?image_id=' + data.image_id;
		tooltip.init();
	}
	else {
		document.getElementById('playlist_cover').innerHTML = '<img src="" alt="">';
		document.getElementById('playlist_cover').firstChild.src = '<?php echo $cfg['img']; ?>large_html5audio.png';
	}
}


function streamTrack(pos) {
	listpos = pos;
	stream();
}


function seek(x) {
	if (seekable[listpos] == false) return;
	var dx = document.getElementById('time_input').clientWidth;
	audio_player.currentTime = playtime[listpos] / 1000 * x / dx;
	updatePlaytime();
	if (audio_player.paused)
		document.getElementById('pause').className = 'pause on onclick';
}


function stop() {
	audio_player.pause();
	audio_player.currentTime = 0;
	document.getElementById('pause').className = 'pause off onclick';
	document.getElementById('play').className = 'play off onclick';
}


function previous() {
	if (listpos > 0) {
		listpos--;
		stream();
	}
}


function next() {
	if (listpos < len) {
		listpos++;
		stream();
	}
}


function pause() {
	if (audio_player.duration == 0) return;
	if (audio_player.paused) {
		audio_player.play();
		document.getElementById('pause').className = 'pause off onclick';
		document.getElementById('play').className = 'play on onclick';
	}
	else {
		audio_player.pause();
		document.getElementById('pause').className = 'pause on onclick';
		document.getElementById('play').className = 'play off onclick';
	}
}


function m3u() {
	audio_player.pause();
	document.getElementById('pause').className = 'pause on onclick';
	document.getElementById('play').className = 'play off onclick';
	location.href='<?php echo $m3u; ?>';
}


function toggleControls() {
	if (audio_one.hasAttribute('controls')) {
		audio_one.removeAttribute('controls');
		audio_two.removeAttribute('controls');
	}
	else {
		audio_one.setAttribute('controls', 'controls');
		audio_two.setAttribute('controls', 'controls');
	}
}


audio_one.onended = function() {
	if (listpos < len) {
		listpos++;
		stream();
	}
	else {
		listpos = 0;
		audio_player.setAttribute('src', dummy);
		document.getElementById('play').className = 'play off onclick';
	}
}


audio_two.onended = function() {
	if (listpos < len) {
		listpos++;
		stream();
	}
	else {
		listpos = 0;
		audio_player.setAttribute('src', dummy);
		document.getElementById('play').className = 'play off onclick';
	}
}
</script>
<?php
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | m3u                                                                    |
//  +------------------------------------------------------------------------+
function m3u() {
	global $cfg, $db;

	$sid	= @$_GET['sid'];
	$hash	= @$_GET['hash'];

	// Manual m3u stream from audio() needed to set html_audio_lossy and html_audio_lossless to false to get a correct list
	$cfg['html_audio_lossy'] = false;
	$cfg['html_audio_lossless'] = false;
	$list = listAuthenticateStream();

	if (preg_match('#iPhone|iPad|iPod#', $_SERVER['HTTP_USER_AGENT']) && $list['miliseconds'][0]) {
		// Use this for all iOS devices except by radio streams
		$target_duration = max($list['miliseconds']);
		$target_duration = ceil($target_duration / 1000);
		$m3u = '#EXTM3U' . "\n";
		$m3u .= '#EXT-X-VERSION:3' . "\n";
		$m3u .= '#EXT-X-TARGETDURATION:' . $target_duration . "\n";
		for ($i = 0; $i < count($list['url']); $i++) {
			$m3u .= '#EXTINF:' . round($list['miliseconds'][$i] / 1000, 2) . ',' . "\n";
			$m3u .= $list['url'][$i] . "\n";
		}
		$m3u .= '#EXT-X-ENDLIST' . "\n";
	}
	else {
		$m3u = '#EXTM3U' . "\n";
		for ($i = 0; $i < count($list['url']); $i++) {
			$m3u .= ($list['miliseconds'][$i]) ? '#EXTINF:' . round($list['miliseconds'][$i] / 1000) . ',' . $list['artist'][$i] . ' - ' . $list['title'][$i] . "\n" : '#EXTINF:-1,' . "\n";
			$m3u .= $list['url'][$i] . "\n";
		}
	}

	$filename = '.netjukebox_';
	$filename .= ($hash) ? $hash : $sid;
	$filename .= '.m3u';

	streamData($m3u, 'audio/mpegurl', 'inline', $filename);
	exit();
}




//  +------------------------------------------------------------------------+
//  | List and Authenticate Stream                                           |
//  +------------------------------------------------------------------------+
function listAuthenticateStream() {
	global $cfg, $db;

	$track_id				= @$_GET['track_id'];
	$album_id				= @$_GET['album_id'];
	$favorite_id			= @$_GET['favorite_id'];
	$random					= @$_GET['random'];
	$sid					= @$_GET['sid'];
	$hash					= @$_GET['hash'];
	$canplay_lossy			= explode(',', @$_COOKIE['netjukebox_canplay_lossy']);
	$canplay_lossless		= explode(',', @$_COOKIE['netjukebox_canplay_lossless']);
	$html_audio_url			= $_SERVER['PHP_SELF'] . '?action=audio';

	$list					= array();
	$list['url']			= array();
	$list['extension']		= array();
	$list['miliseconds']	= array();
	$list['seekable']		= array();
	$list['title']			= array();
	$list['artist']			= array();
	$list['featuring']		= array();
	$list['track_id']		= array();
	$list['info']			= array();
	$list['m3u']			= false;


	if ($hash) {
		// m3u stream
		authenticateStream();
	}
	elseif ($sid) {
		// Share stream
		header('Expires: Mon, 9 Oct 2000 18:00:00 GMT');
		header('Cache-Control: no-store, no-cache, must-revalidate');

		mysqli_query($db, 'UPDATE share_stream SET
			ip			= "' . mysqli_real_escape_string($db, $_SERVER['REMOTE_ADDR']) . '"
			WHERE sid	= BINARY "' . mysqli_real_escape_string($db, $sid) . '"
			AND ip		= ""');

		$query = mysqli_query($db, 'SELECT album_id, stream_id, html_audio_lossy, html_audio_lossless
			FROM share_stream
			WHERE sid = BINARY "' . mysqli_real_escape_string($db, $sid) . '"
			AND ip = "' . mysqli_real_escape_string($db, $_SERVER['REMOTE_ADDR']) . '"
			AND expire_time > ' . (int) time());
		$share_stream = mysqli_fetch_assoc($query);

		if ($share_stream == false || $cfg['album_share_stream'] == false)
			message(__FILE__, __LINE__, 'error', '[b]Stream error[/b][br]This stream is not available any more');

		$album_id		 			= $share_stream['album_id'];
		$cfg['stream_id']			= $share_stream['stream_id'];
		$cfg['html_audio_lossy']	= $share_stream['html_audio_lossy'];
		$cfg['html_audio_lossless']	= $share_stream['html_audio_lossless'];
	}
	else {
		// HTML 5 audio
		authenticate('access_stream');
	}

	if ($sid) {
		$query = mysqli_query($db, 'SELECT artist, title, featuring, relative_file, miliseconds, audio_bitrate, video_dataformat, track_id
			FROM track, share_stream
			WHERE share_stream.sid	= "' . mysqli_real_escape_string($db, $sid) . '" AND
			share_stream.album_id	= track.album_id
			ORDER BY relative_file');
		$html_audio_url .= '&amp;sid=' . rawurlencode($sid);
	}
	elseif ($track_id) {
		$query = mysqli_query($db, 'SELECT artist, title, featuring,relative_file, miliseconds, audio_bitrate, video_dataformat, track_id
			FROM track
			WHERE track_id = "' . mysqli_real_escape_string($db, $track_id) . '"');
		$html_audio_url .= '&amp;track_id=' . rawurlencode($track_id);
	}
	elseif ($album_id) {
		$query = mysqli_query($db, 'SELECT artist, title, featuring, relative_file, miliseconds, audio_bitrate, video_dataformat, track_id
			FROM track
			WHERE album_id = "' . mysqli_real_escape_string($db, $album_id) . '"
			ORDER BY relative_file');
		$html_audio_url .= '&amp;album_id=' . rawurlencode($album_id);
	}
	elseif ($favorite_id) {
		$query = mysqli_query($db, 'SELECT stream
			FROM favorite
			WHERE favorite_id = ' . (int) $favorite_id . '
			AND stream = 1');
		if (mysqli_fetch_row($query)) {
			$query = mysqli_query($db, 'SELECT stream_url FROM favoriteitem WHERE favorite_id = ' . (int) $favorite_id . ' AND stream_url != "" ORDER BY position');
			while ($favoriteitem = mysqli_fetch_assoc($query)) {
				$list['url'][]			= $favoriteitem['stream_url'];
				$list['extension'][]	= 'mp3';
				$list['miliseconds'][]	= 0;
				$list['seekable'][]		= false;
				$list['title'][]		= $favoriteitem['stream_url'];
				$list['artist'][]		= 'Unknown';
				$list['featuring'][]	= '';
				$list['track_id'][]		= '';
				$list['info'][]			= 'External stream';
			}
		$html_audio_url .= '&amp;favorite_id=' . rawurlencode($favorite_id);

		mysqli_query($db, 'UPDATE session SET
			html_audio_url	= "' . mysqli_real_escape_string($db, $html_audio_url) . '"
			WHERE sid		= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');

		return $list;
		}
		$query = mysqli_query($db, 'SELECT artist, title, featuring, relative_file, miliseconds, audio_bitrate, video_dataformat, track.track_id
			FROM track, favoriteitem
			WHERE favoriteitem.track_id = track.track_id
			AND favorite_id = "' . mysqli_real_escape_string($db, $favorite_id) . '"
			ORDER BY position');
		$html_audio_url .= '&amp;favorite_id=' . rawurlencode($favorite_id);
	}
	elseif ($random == 'database') {
		$query = mysqli_query($db, 'SELECT artist, title, featuring, relative_file, miliseconds, audio_bitrate, video_dataformat, track.track_id
			FROM track, random
			WHERE random.sid		= "' . mysqli_real_escape_string($db, $cfg['sid']) . '"
			AND random.track_id		= track.track_id
			ORDER BY position');
		$html_audio_url .= '&amp;random=database&amp;timestamp=' . (isset($_GET['timestamp']) ? rawurlencode($_GET['timestamp']) : dechex(time()));
	}
	elseif ($random == 'generate') {
		mysqli_query($db, 'DELETE FROM random WHERE sid = "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');

		$i = 0;
		$blacklist = explode(',', $cfg['random_blacklist']);
		$blacklist = '"' . implode('","', $blacklist) . '"';
		$query = mysqli_query($db, 'SELECT track.artist, title, track_id
			FROM track, album
			WHERE (genre_id = "" OR genre_id NOT IN (' . $blacklist . '))
			AND audio_dataformat != ""
			AND video_dataformat = ""
			AND track.album_id = album.album_id
			ORDER BY RAND()
			LIMIT 30');
		while ($track = mysqli_fetch_assoc($query)) {
			mysqli_query($db, 'INSERT INTO random (sid, track_id, position, create_time) VALUES (
				"' . mysqli_real_escape_string($db, $cfg['sid']) . '",
				"' . mysqli_real_escape_string($db, $track['track_id']) . '",
				"' . mysqli_real_escape_string($db, $i) . '",
				"' . mysqli_real_escape_string($db, time()) . '")');
			$i++;
		}

		$query = mysqli_query($db, 'SELECT artist, title, featuring, relative_file, miliseconds, audio_bitrate, video_dataformat, track.track_id
			FROM track, random
			WHERE random.sid	= "' . mysqli_real_escape_string($db, $cfg['sid']) . '"
			AND random.track_id	= track.track_id
			ORDER BY position');
		$html_audio_url .= '&amp;random=database&amp;timestamp=' . dechex(time());
	}
	else {
		// return empty list
		$html_audio_url .= '';
		return $list;
	}


	while ($track = mysqli_fetch_assoc($query)) {
		$source_extension = substr(strrchr($track['relative_file'], '.'), 1);
		$source_extension = strtolower($source_extension);

		$query2 = mysqli_query($db, 'SELECT filesize
			FROM cache
			WHERE id		= "' . mysqli_real_escape_string($db, $track['track_id']) . '"
			AND  profile	= "' . mysqli_real_escape_string($db, $cfg['stream_id']) . '"');
		$cache = mysqli_fetch_assoc($query2);
		$cache = ($cache['filesize']) ? true : false;

		if ($track['video_dataformat'] != '' && $source_extension != 'm4a') {
			$stream_id				= -1;
			$extension				= $source_extension;
			$list['info'][]			= 'Video (m3u only) ' . $track['video_dataformat'];
			$list['seekable'][]		= true;
			$list['m3u']			= true;
		}
		elseif ($cfg['html_audio_lossless'] && in_array($source_extension, $canplay_lossless)) {
			$stream_id				= - 1;
			$extension				= $source_extension;
			$list['info'][]			= 'Lossless ' . $source_extension;
			$list['seekable'][]		= true;
		}
		elseif ($cfg['html_audio_lossy'] && in_array($source_extension, $canplay_lossy) && sourceFile($source_extension, $track['audio_bitrate'], $cfg['stream_id'])
		|| $cfg['html_audio_lossy'] && in_array($source_extension, $canplay_lossy) && $source_extension != $cfg['encode_extension'][$cfg['stream_id']]) {
			$stream_id				= - 1;
			$extension				= $source_extension;
			$list['info'][]			= 'Original ' . $source_extension;
			$list['seekable'][]		= true;
		}
		elseif (!$cfg['html_audio_lossy'] && sourceFile($source_extension, $track['audio_bitrate'], $cfg['stream_id'])) {
			$stream_id				= - 1;
			$extension				= $source_extension;
			$list['info'][]			= 'Original (m3u only) ' . $source_extension;
			$list['seekable'][]		= true;
			$list['m3u']			= true;
		}
		elseif ($cache) {
			$stream_id				= $cfg['stream_id'];
			$extension			 	= $cfg['encode_extension'][$cfg['stream_id']];
			$list['info'][]			= $cfg['encode_name'][$cfg['stream_id']] . ' (' . $source_extension . ' source)[hr]Transcoded:[img]' . $cfg['img'] . 'tiny_check.png[/img]';
			$list['seekable'][]		= true;
		}
		else {
			$stream_id				= $cfg['stream_id'];
			$extension				= $cfg['encode_extension'][$cfg['stream_id']];
			$list['info'][]			= $cfg['encode_name'][$cfg['stream_id']] . ' (' . $source_extension . ' source)[hr]Transcoded:[img]' . $cfg['img'] . 'tiny_uncheck.png[/img]';
			$list['seekable'][]		= false;
		}

		if ($sid) {
			// Share stream
			$url = NJB_HOME_URL . 'stream.php?action=stream';
			$url .= '&stream_id=' . rawurlencode($stream_id);
			$url .= '&track_id=' . $track['track_id'];
			$url .= '&sid=' . rawurlencode($sid);
			$url .= '&ext=.' . rawurlencode($extension);
		}
		elseif ($hash) {
			// m3u stream
			$url = NJB_HOME_URL . 'stream.php?action=stream';
			$url .= '&stream_id=' . rawurlencode($stream_id);
			$url .= '&track_id=' . $track['track_id'];
			$url .= '&short_sid=' . substr($cfg['sid'], 0, 8);
			$url .= '&hash=' . hash_hmac('sha1', $cfg['sid'] . 'stream' . $stream_id . $track['track_id'], $cfg['server_salt']);
			$url .= '&ext=.' . rawurlencode($extension);
		}
		else {
			// HTML 5 audio
			$url = NJB_HOME_URL . 'stream.php?action=stream';
			$url .= '&stream_id=' . rawurlencode($stream_id);
			$url .= '&track_id=' . $track['track_id'];
		}

		$list['url'][]			= $url;
		$list['extension'][]	= $extension;
		$list['miliseconds'][]	= $track['miliseconds'];
		$list['title'][]		= $track['title'];
		$list['artist'][]		= $track['artist'];
		$list['featuring'][]	= $track['featuring'];
		$list['track_id'][]		= $track['track_id'];
	}

	if (isset($cfg['sid']) && $album_id)
		updateCounter($album_id, NJB_COUNTER_STREAM);

	if (isset($cfg['sid'])) {
		mysqli_query($db, 'UPDATE session SET
			html_audio_url	= "' . mysqli_real_escape_string($db, $html_audio_url) . '"
			WHERE sid		= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
	}

	/*
	echo '<pre>';
	print_r($list);
	echo '<hr>';
	print_r($cfg);
	echo '</pre>';
	exit();
	*/

	return $list;
}




//  +------------------------------------------------------------------------+
//  | Stream                                                                 |
//  +------------------------------------------------------------------------+
function stream() {
	global $cfg, $db;

	$track_id	= @$_GET['track_id'];
	$stream_id	= (int) @$_GET['stream_id'];
	$sid		= @$_GET['sid'];
	$hash		= @$_GET['hash'];

	if ($stream_id != -1 && isset($cfg['encode_extension'][$stream_id]) == false) {
		header('HTTP/1.1 400 Bad Request');
		exit();
	}

	if ($sid) {
		// Share stream
		authenticateShareStream();
	}
	elseif ($hash) {
		// m3u stream
		authenticateStream();
	}
	else {
		// HTML 5 audio
		authenticate('access_stream', true);
	}

	$query = mysqli_query($db, 'SELECT LOWER(SUBSTRING_INDEX(relative_file, ".", -1)) AS extension, relative_file, mime_type, audio_bitrate
		FROM track
		WHERE track_id = "' . mysqli_real_escape_string($db, $track_id) . '"');
	$track = mysqli_fetch_assoc($query);
	$file = $cfg['media_dir'] . $track['relative_file'];

	if (sourceFile($track['extension'], $track['audio_bitrate'], $stream_id)) {
		// Stream from source
		streamFile($file, $track['mime_type']);
	}
	elseif ($cache = cacheGetFile($track_id, $stream_id)) {
		// Stream from cache
		cacheUpdateTag($track_id, $stream_id, $cache);
		streamFile($cache, $cfg['encode_mime_type'][$stream_id]);
	}
	else {
		// Real time transcode stream
		ini_set('max_execution_time', 0);

		if (file_exists(NJB_HOME_DIR . '-'))
			@unlink(NJB_HOME_DIR . '-');

		$cmd = $cfg['decode_stdout'][$track['extension']] . ' | ' . $cfg['encode_stdout'][$stream_id];
		$cmd = str_replace('%source', escapeCmdArg($file), $cmd);

		header('Accept-Ranges: none');
		header('Content-Type: ' . $cfg['encode_mime_type'][$stream_id]);

		if (@passthru($cmd) == false) {
			header('HTTP/1.1 500 Internal Server Error');
			exit();
		}
	}
}




//  +------------------------------------------------------------------------+
//  | Authenticate share stream                                              |
//  +------------------------------------------------------------------------+
function authenticateShareStream() {
	global $cfg, $db;
	header('Expires: Mon, 9 Oct 2000 18:00:00 GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');

	$sid		= @$_GET['sid'];
	$track_id	= @$_GET['track_id'];
	$album_id	= substr($track_id, 0, strpos($track_id, '_'));
	$stream_id	= @$_GET['stream_id'];

	$query = mysqli_query($db, 'SELECT ip, album_id, stream_id, html_audio_lossless, expire_time FROM share_stream
		WHERE sid = BINARY "' . mysqli_real_escape_string($db, $sid) . '"');
	$share_stream = mysqli_fetch_assoc($query);

	if ($share_stream['ip']			== $_SERVER['REMOTE_ADDR'] &&
		$share_stream['album_id']	== $album_id &&
		(($share_stream['stream_id'] == $stream_id) || ($share_stream['html_audio_lossless'] && $stream_id == -1)) &&
		$share_stream['expire_time'] > time())
		return true;

	header('HTTP/1.1 403 Forbidden');
	exit();
}




//  +------------------------------------------------------------------------+
//  | Share album                                                            |
//  +------------------------------------------------------------------------+
function shareAlbum($album_id) {
	global $cfg, $db;
	authenticate('access_admin', true, true);

	if ($cfg['album_share_stream'] == false)
		message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]Share album disabled');

	$query = mysqli_query($db, 'SELECT artist_alphabetic, album, year
		FROM album
		WHERE album_id = "' . mysqli_real_escape_string($db, $album_id) . '"');
	$album = mysqli_fetch_assoc($query);

	if ($album == false)
		message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]album_id not found in database');

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Media';
	$nav['url'][]	= 'index.php';
	$nav['name'][]	= $album['artist_alphabetic'];
	$nav['url'][]	= 'index.php?action=view2&amp;artist=' . rawurlencode($album['artist_alphabetic']);
	$nav['name'][]	= $album['album'];
	$nav['url'][]	= 'index.php?action=view3&amp;album_id=' . $album_id;
	$nav['name'][]	= 'Share stream';
	require_once('include/header.inc.php');

	$expire_time = time() + $cfg['share_stream_lifetime'];
	$sid = randomSid();
	mysqli_query($db, 'INSERT INTO share_stream (sid, album_id, stream_id, html_audio_lossy, html_audio_lossless, expire_time) VALUES (
		"' . mysqli_real_escape_string($db, $sid) . '",
		"' . mysqli_real_escape_string($db, $album_id) . '",
		' . (int) $cfg['stream_id'] . ',
		' . (int) $cfg['html_audio_lossy'] . ',
		' . (int) $cfg['html_audio_lossless'] . ',
		' . (int) $expire_time . ')');

	$url	= NJB_HOME_URL . 'stream.php?action=audio&amp;sid=' . $sid;

	$name	= $album['artist_alphabetic'] . ' - ';
	$name	.=  ($album['year']) ? $album['year'] . ' - ' : '';
	$name	.= $album['album'];
	// $name 	= encodeEscapeChar($name);

	$transcode		= false;
	$exact			= true;
	$extensions		= array();
	$miliseconds	= 0;
	$query = mysqli_query($db, 'SELECT track.filesize, cache.filesize AS cache_filesize,
		miliseconds, audio_bitrate, track_id,
		LOWER(SUBSTRING_INDEX(track.relative_file, ".", -1)) AS extension
		FROM track LEFT JOIN cache
		ON track.track_id = cache.id
		AND cache.profile = ' . (int) $cfg['stream_id'] . '
		WHERE album_id = "' . mysqli_real_escape_string($db, $album_id) . '"');
	while($track = mysqli_fetch_assoc($query)) {
		if (in_array($track['extension'], $extensions) == false) {
			$extensions[] = $track['extension'];
		}
		if (sourceFile($track['extension'], $track['audio_bitrate'], $cfg['stream_id']) == false) {
			$transcode = true;
			if ($track['cache_filesize'] == false)
				$exact = false;
		}
		$miliseconds += $track['miliseconds'];
	}

	sort($extensions);
	$source = implode($extensions, ', ');

	$profile_name = ($transcode) ? $cfg['encode_name'][$cfg['stream_id']] . ' (' . $source . ' source)' : 'Source (' . $source . ')';

	if ($transcode && $exact)		{$cache_txt = 'Transcoded:'; 	$cache_png = $cfg['img'] . 'small_check.png';}
	elseif ($transcode && !$exact)	{$cache_txt = 'Transcoded:'; 	$cache_png = $cfg['img'] . 'small_uncheck.png';}
	else							{$cache_txt = 'Source:'; 		$cache_png = $cfg['img'] . 'small_check.png';}
?>
<table class="border">
<tr class="header">
	<td class="space"></td>
	<td colspan="3"><?php echo html($name); ?></td>
	<td class="space"></td>
</tr>
<tr class="odd">
	<td></td>
	<td>Play time:</td>
	<td></td>
	<td><?php echo formattedTime($miliseconds); ?></td>
	<td class="space"></td>
</tr>
<tr class="even">
	<td class="space"></td>
	<td>Stream profile:</td>
	<td class="textspace"></td>
	<td><?php echo html($profile_name); ?></td>
	<td class="space"></td>
</tr>
<tr class="odd">
	<td class="space"></td>
	<td>Lossy HTML audio:</td>
	<td class="textspace"></td>
	<td><img src="<?php echo $cfg['img'] . (($cfg['html_audio_lossy']) ? 'small_check.png' : 'small_uncheck.png'); ?>" alt="" class="small"></td>
	<td class="space"></td>
</tr>
<tr class="even">
	<td class="space"></td>
	<td>Lossless HTML audio:</td>
	<td class="textspace"></td>
	<td><img src="<?php echo $cfg['img'] . (($cfg['html_audio_lossless']) ? 'small_check.png' : 'small_uncheck.png'); ?>" alt="" class="small"></td>
	<td class="space"></td>
</tr>
<tr class="odd">
	<td></td>
	<td><?php echo $cache_txt; ?></td>
	<td></td>
	<td><img src="<?php echo $cache_png; ?>" alt="" class="small"></td>
	<td class="space"></td>
</tr>
<tr class="even">
	<td></td>
	<td>Mail:</td>
	<td></td>
	<td><a href="mailto:?SUBJECT=<?php echo rawurlencode($name); ?>&amp;BODY=---%0APlay%20time%3A%20<?php echo rawurlencode(formattedTime($miliseconds));?>%0AStream%3A%20<?php echo rawurlencode($name); ?>%0A<?php echo rawurlencode(str_replace('&amp;', '&', $url)); ?>%0A%0AThis%20stream%20will%20expire%20<?php echo  rawurlencode(date($cfg['date_format'], $expire_time)); ?>%20and%20locked%20to%20the%20first%20used%20IP%20address."><img src="<?php echo $cfg['img']; ?>small_mail.png" alt="" class="small"></a></td>
	<td></td>
</tr>
<tr class="odd">
	<td></td>
	<td>URL:</td>
	<td></td>
	<td><input type="text" value="<?php echo $url; ?>" readonly class="edit" onclick="focus(this); select(this);"></td>
	<td></td>
</tr>
<tr class="even">
	<td></td>
	<td>QR Code:</td>
	<td></td>
	<td><img src="qrcode.php?data=<?php echo rawurlencode(str_replace('&amp;', '&', $url)); ?>" alt="" class="qrcode"></td>
	<td></td>
</tr>
</table>
<?php
	require_once('include/footer.inc.php');
}
