<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | upload.php                                                             |
//  +------------------------------------------------------------------------+
require_once('include/initialize.inc.php');
require_once('include/cache.inc.php');
$cfg['menu'] = 'config';

if (ini_get('file_uploads') == false)
	message(__FILE__, __LINE__, 'error', '[b]File uploads disabled[/b][br]Set file_uploads to On in the php.ini.');

$action	= @$_REQUEST['action'];

if 		($action == 'selectFiles')	selectFiles();
elseif 	($action == 'uploadFiles')	uploadFiles();
elseif 	($action == 'selectImage')	selectImage();
elseif  ($action == 'uploadImage')	uploadImage();
elseif	($action == '' && empty($_FILES)) message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Check the following values in php.ini[list][*]file_uploads = On[*]upload_max_filesize =[*]max_file_uploads =[*]post_max_size =[/list]');
else	message(__FILE__, __LINE__, 'error', '[b]Unsupported input value for[/b][br]action');




//  +------------------------------------------------------------------------+
//  | Select files                                                           |
//  +------------------------------------------------------------------------+
function selectFiles() {
	global $cfg, $db;
	authenticate('access_upload');

	$root = @$_GET['root'];

	$nav			= array();
	$nav['name'][]	= 'Configuration';
	$nav['class'][]	= 'nav';
	$nav['url'][]	= 'config.php';

	$nav['name'][]	= 'Upload';
	$nav['class'][]	= 'nav';
	$nav['url'][]	= null;

	if ($cfg['access_admin'] && count(@scandir($cfg['upload_dir'])) > 2) {
		$nav['name'][]	= 'File manager';
		$nav['class'][]	= 'suggest';
		$nav['url'][]	= 'config.php?action=fileManager&amp;root=upload';
	}
	elseif (count(@scandir($cfg['upload_dir'] . uploadFilename($cfg['username']) . '/')) > 2) {
		$nav['name'][]	= 'File manager';
		$nav['class'][]	= 'suggest';
		$nav['url'][]	= 'config.php?action=fileManager&amp;root=user';
	}

	require_once('include/header.inc.php');
?>
<form action="upload.php" method="post" enctype="multipart/form-data" onsubmit="upload(); return false;" id="uploadform" autocomplete="off">
	<input type="hidden" name="action" value="uploadFiles">
	<input type="hidden" name="sign" value="<?php echo html($cfg['sign']); ?>">
<table class="border bottom_space">
<tr class="header">
	<td></td>
	<td colspan="3">Directory structure</td>
	<td></td>
</tr>
<tr class="odd">
	<td class="space"></td>
	<td>Artist:</td>
	<td class="textspace"></td>
	<td><input type="text" name="artist" class="edit" autofocus></td>
	<td class="space"></td>
</tr>
<tr class="even">
	<td class="space"></td>
	<td>Album:</td>
	<td class="textspace"></td>
	<td><input type="text" name="album" class="edit"></td>
	<td class="space"></td>
</tr>
<tr class="odd">
	<td class="space"></td>
	<td>Year:</td>
	<td class="textspace"></td>
	<td><input type="text" name="year" class="year" maxlength="4" onkeyup="vallidateYear(this);"></td>
	<td class="space"></td>
</tr>
<tr class="header">
	<td></td>
	<td colspan="3">Files</td>
	<td></td>
</tr>
<tr class="odd">
	<td class="space"></td>
	<td>Media files:</td>
	<td class="textspace"></td>
	<td><input type="file" name="media[]" accept=".<?php sort($cfg['media_extension']); echo html(implode(', .', $cfg['media_extension'])); ?>" multiple class="edit" onchange="file_selected = true;"></td>
	<td class="space"></td>
</tr>
<tr class="even">
	<td class="space"></td>
	<td>Front cover:</td>
	<td class="textspace"></td>
	<td><input type="file" name="image_front" accept="image/jpeg, image/png"></td>
	<td class="space"></td>
</tr>
<tr class="odd">
	<td class="space"></td>
	<td>Back cover:</td>
	<td class="textspace"></td>
	<td><input type="file" name="image_back" accept="image/jpeg, image/png"></td>
	<td class="space"></td>
</tr>
</table>
<a href="javascript:upload();" class="button">upload</a><!--
--><a href="config.php" class="button">cancel</a>
<input type="submit" style="display: none;">
</form>
<script>
var file_selected = false;


function vallidateYear(obj) {
	var year = obj.value;
	if (year == '' || (year >= 1877 && year <= <?php echo date('Y'); ?>))
		obj.classList.remove('error');
	else
		obj.classList.add('error');
}


function upload() {
	if (file_selected)
		document.getElementsByName('media[]')[0].classList.remove('error');
	else {
		document.getElementsByName('media[]')[0].classList.add('error');
		document.getElementsByName('media[]')[0].focus();
	}

	if (uploadform.album.value)
	 	uploadform.album.classList.remove('error');

	else {
		uploadform.album.classList.add('error');
		uploadform.album.focus();
	}

	if (uploadform.artist.value)
		uploadform.artist.classList.remove('error');
	else {
		uploadform.artist.classList.add('error');
		uploadform.artist.focus();
	}

	if (uploadform.artist.value && uploadform.album.value && file_selected)
		uploadform.submit();
}
</script>
<?php
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Upload files                                                           |
//  +------------------------------------------------------------------------+
function uploadFiles() {
	global $cfg, $db;
	authenticate('access_upload', true, true);

	require_once('lib/getid3/getid3/getid3.php');

	$artist	= trim(@$_POST['artist']) or message(__FILE__, __LINE__, 'error', '[b]Artist must be set[/b]');
	$album	= trim(@$_POST['album']) or message(__FILE__, __LINE__, 'error', '[b]Album must be set[/b]');
	$year	= (int) @$_POST['year'];

	if ($artist[0] == '.' || ($year == 0 && $album[0] == '.'))
		message(__FILE__, __LINE__, 'error', '[b]You can’t use a directory that starts with a dot[/b]');

	if (NJB_WINDOWS) {
		// On Windows remove unsupported trailing dots
		$artist = rtrim($artist, '.');
		$album	= rtrim($album, '.');
	}

	if (empty($_FILES['media']['name'][0]))
		message(__FILE__, __LINE__, 'error', '[b]At least one media file must be selected[/b]');

	// Check if album already exist (case insensitive)
	$query = mysqli_query($db, 'SELECT album, artist
		FROM album
		WHERE (artist = "' . mysqli_real_escape_string($db, $artist) . '" OR artist_alphabetic = "' . mysqli_real_escape_string($db, $artist) . '")
		AND album = "' . mysqli_real_escape_string($db, $album) . '"');

	if ($temp = mysqli_fetch_assoc($query))
		message(__FILE__, __LINE__, 'warning', '[b]Album already exist:[/b][list][*]' . $temp['artist'] . '[*]' . $temp['album'] . '[/list][br][url=upload.php?action=selectFiles][img]small_back.png[/img]Back to previous page[/url]');

	$path = uploadFilename($artist) . '/';
	$path .= ($year >= 1877 && $year <= date('Y')) ? $year . ' - ' : '';
	$path .= uploadFilename($album) . '/';

	// Create upload directory
	$dir = $cfg['upload_dir'] . uploadFilename($cfg['username']) . '/' . $path;
	if (is_dir($dir) == false && @mkdir($dir, 0777, true) == false)
		message(__FILE__, __LINE__, 'error', '[b]Failed to create directory:[/b][br]' . $dir);

	// Initialize getID3
	$getID3 = new getID3;
	// public: Settings
	$getID3->encoding					= $cfg['default_charset'];	// CASE SENSITIVE! - i.e. (must be supported by iconv()) Examples:  ISO-8859-1  UTF-8  UTF-16  UTF-16BE
	$getID3->encoding_id3v1				= 'ISO-8859-1';				// Should always be 'ISO-8859-1', but some tags may be written in other encodings such as 'EUC-CN'
	// public: Optional tag checks - disable for speed.
	$getID3->option_tag_id3v1			= false;		// Read and process ID3v1 tags
	$getID3->option_tag_id3v2			= false;		// Read and process ID3v2 tags
	$getID3->option_tag_lyrics3			= false;		// Read and process Lyrics3 tags
	$getID3->option_tag_apetag			= false;		// Read and process APE tags
	$getID3->option_tags_process		= false;		// Copy tags to root key 'tags' and encode to $this->encoding
	$getID3->option_tags_html			= false;		// Copy tags to root key 'tags_html' properly translated from various encodings to HTML entities
	// public: Optional tag/comment calucations
	$getID3->option_extra_info			= true;			// Calculate additional info such as bitrate, channelmode etc
	// public: Optional handling of embedded attachments (e.g. images)
	$getID3->option_save_attachments	= false;		// defaults to true (ATTACHMENTS_INLINE) for backward compatibility
	// public: Optional calculations
	$getID3->option_md5_data			= false;		// Get MD5 sum of data part - slow
	$getID3->option_md5_data_source		= false;		// Use MD5 of source file if availble - only FLAC and OptimFROG
	$getID3->option_sha1_data			= false;		// Get SHA1 sum of data part - slow
	$getID3->option_max_2gb_check		= null;			// Check whether file is larger than 2GB and thus not supported by 32-bit PHP

	// Upload media files
	for ($i = 0; $i < count($_FILES['media']['name']); $i++) {
		validateUpload($_FILES['media']['error'][$i]);
		$file = trim($_FILES['media']['name'][$i]);

		if ($file[0] == '.')
			message(__FILE__, __LINE__, 'error', '[b]You can’t use a filename that starts with a dot[/b]');

		// Validate file extension
		$extension = substr(strrchr($file, '.'), 1);
		$extension = strtolower($extension);
		if (in_array($extension, $cfg['media_extension']) == false)
			message(__FILE__, __LINE__, 'error', '[b]Unsupported extension[/b][br]' . $extension);

		// Validate file with getID3()
		$getID3->analyze($_FILES['media']['tmp_name'][$i]);
		if (isset($getID3->info['error']) || (isset($getID3->info['audio']) == false && isset($getID3->info['video']) == false))
			message(__FILE__, __LINE__, 'error', '[b]Unsupported or corrupted file[/b][br]' . $file);

		// Move file
		$file = substr($file, 0, -strlen($extension)) . $extension;
		$file = $dir . uploadFilename($file);
		if (move_uploaded_file($_FILES['media']['tmp_name'][$i], $file) == false)
			message(__FILE__, __LINE__, 'error', '[b]Failed to move file[/b][br]from: ' . $_FILES['media']['tmp_name'][$i] . '[br]to: ' . $file);
		chmod($file, 0666);
	}

	// Validate image upload
	if ($_FILES['image_front']['error'] != UPLOAD_ERR_NO_FILE)
		validateUpload($_FILES['image_front']['error']);
	elseif ($_FILES['image_back']['error'] != UPLOAD_ERR_NO_FILE)
		validateUpload($_FILES['image_back']['error']);

	// Upload front cover
	if ($_FILES['image_front']['error'] == UPLOAD_ERR_OK) {
		$imagesize = @getimagesize($_FILES['image_front']['tmp_name']);
		if ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_JPEG)
			$image = $dir . $cfg['image_front'] . '.jpg';
		elseif ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_PNG)
			$image = $dir . $cfg['image_front'] . '.png';
		else
			message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Unsupported front cover.');

		if (move_uploaded_file($_FILES['image_front']['tmp_name'], $image) == false)
			message(__FILE__, __LINE__, 'error', '[b]Failed to move file[/b][br]from: ' . $_FILES['image_front']['tmp_name'] . '[br]to: ' . $image);
		chmod($image, 0666);
	}

	// Upload back cover
	if ($_FILES['image_back']['error'] == UPLOAD_ERR_OK) {
	    $imagesize = @getimagesize($_FILES['image_back']['tmp_name']);
	    if ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_JPEG)
	        $image = $dir . $cfg['image_back'] . '.jpg';
	    elseif ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_PNG)
	        $image = $dir . $cfg['image_back'] . '.png';
	    else
	        message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Unsupported back cover.');

	    if (move_uploaded_file($_FILES['image_back']['tmp_name'], $image) == false)
	        message(__FILE__, __LINE__, 'error', '[b]Failed to move file[/b][br]from: ' . $_FILES['image_back']['tmp_name'] . '[br]to: ' . $image);
	    chmod($image, 0666);
	}

	if ($cfg['access_admin'])
		header('Location: ' . NJB_HOME_URL . 'config.php?action=fileManager&root=upload&path=' . rawurldecode(uploadFilename($cfg['username']) . '/' . $path));
	else
		header('Location: ' . NJB_HOME_URL . 'config.php?action=fileManager&root=user&path=' . rawurldecode($path));
}




//  +------------------------------------------------------------------------+
//  | Select image                                                           |
//  +------------------------------------------------------------------------+
function selectImage() {
	global $cfg, $db;
	authenticate('access_admin');

	$album_id	= @$_GET['album_id'];
	$flag		= (int) @$_GET['flag'];

	$query = mysqli_query($db, 'SELECT artist, artist_alphabetic, album, album_id
		FROM album
		WHERE album_id = "' . mysqli_real_escape_string($db, $album_id) . '"');
	$album = mysqli_fetch_assoc($query);

	if ($album == false)
		message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]album_id not found in database');

	if ($flag == 0 || $flag == 1) {
		$cancel = 'update.php?action=imageUpdate&amp;flag=' . $flag;
		// Navigator
		$nav			= array();
		$nav['name'][]	= 'Configuration';
		$nav['url'][]	= 'config.php';
		$nav['name'][]	= 'Update cover';
		$nav['url'][]	= 'update.php?action=imageUpdate&amp;flag=' . $flag;
		$nav['name'][]	= 'Upload';
	}
	elseif ($flag == 9) {
		$cfg['menu'] = 'index';
		$cancel = 'index.php?action=view3&amp;album_id=' . $album_id;
		// Navigator
		$nav			= array();
		$nav['name'][]	= 'Media';
		$nav['url'][]	= 'index.php';
		$nav['name'][]	= $album['artist_alphabetic'];
		$nav['url'][]	= 'index.php?action=view2&amp;artist=' . rawurlencode($album['artist_alphabetic']);
		$nav['name'][]	= $album['album'];
		$nav['url'][]	= 'index.php?action=view3&amp;album_id=' . $album_id;
		$nav['name'][]	= 'Update cover';
		$nav['url'][]	= 'update.php?action=imageUpdate&amp;flag=9&amp;album_id=' . $album_id;
		$nav['name'][]	= 'Upload';
	}
	else
		message(__FILE__, __LINE__, 'error', '[b]Error internet image update[/b][br]Unsupported flag set');

	require_once('include/header.inc.php');
?>
<form action="upload.php" method="post" enctype="multipart/form-data" id="uploadform">
	<input type="hidden" name="action" value="uploadImage">
	<input type="hidden" name="flag" value="<?php echo $flag; ?>">
	<input type="hidden" name="album_id" value="<?php echo $album_id; ?>">
	<input type="hidden" name="sign" value="<?php echo html($cfg['sign']); ?>">
<table class="border bottom_space">
<tr class="header">
	<td></td>
	<td colspan="3">Upload</td>
	<td></td>
</tr>
<tr class="odd">
	<td class="space"></td>
	<td>Front cover:</td>
	<td class="textspace"></td>
	<td><input type="file" name="image_front" accept="image/jpeg, image/png"></td>
	<td class="space"></td>
</tr>
<tr class="even">
	<td class="space"></td>
	<td>Back cover:</td>
	<td class="textspace"></td>
	<td><input type="file" name="image_back" accept="image/jpeg, image/png"></td>
	<td class="space"></td>
</tr>
</table>
<a href="javascript:uploadform.submit();" class="button">upload</a><!--
--><a href="<?php echo $cancel; ?>" class="button">cancel</a>
</form>
<?php
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Upload image                                                           |
//  +------------------------------------------------------------------------+
function uploadImage() {
	global $cfg, $db;
	authenticate('access_admin', true, true);

	$album_id	= @$_POST['album_id'];
	$flag_flow	= (int) @$_POST['flag'];
	$query		= mysqli_query($db, 'SELECT relative_file FROM track WHERE album_id = "' . mysqli_real_escape_string($db, $album_id) . '"');
	$track		= mysqli_fetch_assoc($query);
	$image_dir	= $cfg['media_dir'] . $track['relative_file'];
	$image_dir	= substr($image_dir, 0, strrpos($image_dir, '/') + 1);

	if ($track == false)
		message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]album_id not found in database');

	// Validate upload
	if ($_FILES['image_front']['error'] != UPLOAD_ERR_NO_FILE)
		validateUpload($_FILES['image_front']['error']);
	elseif ($_FILES['image_back']['error'] != UPLOAD_ERR_NO_FILE)
		validateUpload($_FILES['image_back']['error']);
	else
		message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]There is no image file uploaded');

	if ($_FILES['image_front']['error'] == UPLOAD_ERR_OK) {
		$imagesize = @getimagesize($_FILES['image_front']['tmp_name']);
		if ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_JPEG) {
			$image = $image_dir . $cfg['image_front'] . '.jpg';
			$delete = $image_dir . $cfg['image_front'] . '.png';
		}
		elseif ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_PNG) {
			$image = $image_dir . $cfg['image_front'] . '.png';
			$delete = $image_dir . $cfg['image_front'] . '.jpg';
		}
		else
			message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Unsupported front cover.');

		if (move_uploaded_file($_FILES['image_front']['tmp_name'], $image) == false)
			message(__FILE__, __LINE__, 'error', '[b]Failed to move file[/b][br]from: ' . $_FILES['image_front']['tmp_name'] . '[br]to: ' . $image);
		chmod($image, 0666);

		$flag		= 3; // stored
		$filemtime	= filemtime($image);
		$filesize	= filesize($image);
		$image_id	= $album_id . '_' . base_convert(NJB_IMAGE_SIZE * 100 + NJB_IMAGE_QUALITY, 10, 36) . base_convert($filemtime, 10, 36) . base_convert($filesize, 10, 36);

		$relative_image = substr($image, strlen($cfg['media_dir']));
		mysqli_query($db, 'UPDATE bitmap SET
			image				= "' . mysqli_real_escape_string($db, resampleImage($image)) . '",
			filesize			= ' . (int) $filesize . ',
			filemtime			= ' . (int) $filemtime . ',
			flag				= ' . (int) $flag . ',
			image_front			= "' . mysqli_real_escape_string($db, $relative_image) . '",
			image_front_width	= ' . (int) $imagesize[0] . ',
			image_front_height	= ' . (int) $imagesize[1] . ',
			image_id			= "' . mysqli_real_escape_string($db, $image_id) . '"
			WHERE album_id		= "' . mysqli_real_escape_string($db, $album_id) . '"');

		mysqli_query($db, 'UPDATE album SET
			image_id			= "' . mysqli_real_escape_string($db, $image_id) . '"
			WHERE album_id		= "' . mysqli_real_escape_string($db, $album_id) . '"');
	}

	if ($_FILES['image_back']['error'] == UPLOAD_ERR_OK) {
		$imagesize = @getimagesize($_FILES['image_back']['tmp_name']);
		if ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_JPEG) {
			$image = $image_dir . $cfg['image_back'] . '.jpg';
			$delete = $image_dir . $cfg['image_back'] . '.png';
		}
		elseif ($imagesize !== false && isset($imagesize[2]) && $imagesize[2] == IMAGETYPE_PNG) {
			$image = $image_dir . $cfg['image_back'] . '.png';
			$delete = $image_dir . $cfg['image_back'] . '.jpg';
		}
		else message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Unsupported back cover.');

		if (move_uploaded_file($_FILES['image_back']['tmp_name'], $image) == false)
				message(__FILE__, __LINE__, 'error', '[b]Failed to move file[/b][br]from: ' . $_FILES['image_back']['tmp_name'] . '[br]to: ' . $image);
		chmod($image, 0666);


		$relative_image = substr($image, strlen($cfg['media_dir']));
		mysqli_query($db, 'UPDATE bitmap SET
			image_back			= "' . mysqli_real_escape_string($db, $relative_image) . '"
			WHERE album_id		= "' . mysqli_real_escape_string($db, $album_id) . '"');
	}

	if ($flag_flow == 9) {
		header('Location: ' . NJB_HOME_URL . 'index.php?action=view3&album_id=' . $album_id);
		exit();
	}
	else {
        header('Location: ' . NJB_HOME_URL . 'update.php?action=imageUpdate&flag=' . $flag_flow);
        exit();
    }
}




//  +------------------------------------------------------------------------+
//  | Validate upload error                                                  |
//  +------------------------------------------------------------------------+
function validateUpload($error) {
	if ($error == UPLOAD_ERR_OK)				return true; // Value 0
	elseif ($error == UPLOAD_ERR_INI_SIZE)		message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]The uploaded file exceeds the upload_max_filesize directive in php.ini.'); // Value 1
	elseif ($error == UPLOAD_ERR_FORM_SIZE)		message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.'); // Value 02
	elseif ($error == UPLOAD_ERR_PARTIAL)		message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]The uploaded file was only partially uploaded.'); // Value 03
	elseif ($error == UPLOAD_ERR_NO_FILE)		message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]No file was uploaded.'); // Value 04
	elseif ($error == UPLOAD_ERR_NO_TMP_DIR)	message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Missing a temporary folder.'); // Value 06
	elseif ($error == UPLOAD_ERR_CANT_WRITE)	message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Failed to write file to disk.'); // Value 07
	elseif ($error == UPLOAD_ERR_EXTENSION)		message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]A PHP extension stopped the file upload.'); // Value 08
	else										message(__FILE__, __LINE__, 'error', '[b]Upload error[/b][br]Unknown upload error.');
}
