<?php
//  +------------------------------------------------------------------------+
//  | netjukebox, Copyright (C) 2001-2017 Willem Bartels                     |
//  |                                                                        |
//  | http://www.netjukebox.nl                                               |
//  | http://forum.netjukebox.nl                                             |
//  |                                                                        |
//  | This program is free software: you can redistribute it and/or modify   |
//  | it under the terms of the GNU General Public License as published by   |
//  | the Free Software Foundation, either version 3 of the License, or      |
//  | (at your option) any later version.                                    |
//  |                                                                        |
//  | This program is distributed in the hope that it will be useful,        |
//  | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
//  | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
//  | GNU General Public License for more details.                           |
//  |                                                                        |
//  | You should have received a copy of the GNU General Public License      |
//  | along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
//  +------------------------------------------------------------------------+




//  +------------------------------------------------------------------------+
//  | users.php                                                              |
//  +------------------------------------------------------------------------+
require_once('include/initialize.inc.php');
$cfg['menu'] = 'config';

$action = @$_REQUEST['action'];

if		($action == '')						home();

elseif	($action == 'editUser')				editUser();
elseif	($action == 'updateUser')			{updateUser(); home();}
elseif	($action == 'deleteUser')			{deleteUser(); home();}

elseif	($action == 'currentUser')			currentUser();
elseif	($action == 'updateCurrentUser')	updateCurrentUser(); /* and ridirect to config.php */

elseif	($action == 'online')				online();
elseif	($action == 'resetSessions')		{resetSessions(); online();}

elseif	($action == 'userStatistics')		userStatistics();
elseif	($action == 'resetUserStatistics')	{resetUserStatistics(); userStatistics();}

else	message(__FILE__, __LINE__, 'error', '[b]Unsupported input value for[/b][br]action');




//  +------------------------------------------------------------------------+
//  | Home                                                                   |
//  +------------------------------------------------------------------------+
function home() {
	global $cfg, $db;
	authenticate('access_admin');

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Configuration';
	$nav['url'][]	= 'config.php';
	$nav['name'][]	= 'Users';
	require_once('include/header.inc.php');
?>
<table class="border">
<tr class="header">
	<td class="space"></td>
	<td>Username</td>
	<td class="textspace"></td>
	<td class="matrix">Media</td>
	<td class="matrix">Popular</td>
	<td class="matrix">Favorite</td>
	<td class="matrix">Play</td>
	<td class="matrix">Stream</td>
	<td class="matrix">Download</td>
	<td class="matrix">Upload</td>
	<td class="matrix">Cover</td>
	<td class="matrix">Statistics</td>
	<td class="matrix">Admin</td>
	<td class="space"></td>
	<td><a href="users.php?action=editUser&amp;user_id=0" title="Add a new user"><img src="<?php echo $cfg['img']; ?>small_header_new.png" alt="" class="small"></a></td>
	<td class="space"></td>
</tr>
<?php
	$i=0;
	$check = '<img src="' . $cfg['img'] . 'small_check.png" alt="" class="small space">';
	$uncheck = '<img src="' . $cfg['img'] . 'small_uncheck.png" alt="" class="small space">';
	$query = mysqli_query($db, 'SELECT username, access_media, access_popular, access_cover, access_stream, access_play, access_download, access_upload, access_favorite, access_statistics, access_admin, user_id FROM user ORDER BY username');
	while ($user = mysqli_fetch_assoc($query)) { ?>
<tr class="<?php if ($cfg['username'] == $user['username']) echo 'select'; else echo ($i & 1) ? 'even mouseover' : 'odd mouseover'; $i++ ?>">
	<td></td>
	<td><a href="users.php?action=editUser&amp;user_id=<?php echo $user['user_id']; ?>"><img src="<?php echo $cfg['img']; ?>small_user.png" alt="" class="small space"><?php echo html($user['username']); ?></a></td>
	<td></td>
	<td class="matrix" <?php echo accessInfoTitle('media'); ?>><?php echo $user['access_media'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('popular'); ?>><?php echo $user['access_popular'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('favorite'); ?>><?php echo $user['access_favorite'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('play'); ?>><?php echo $user['access_play'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('stream'); ?>><?php echo $user['access_stream'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('download'); ?>><?php echo $user['access_download'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('upload'); ?>><?php echo $user['access_upload'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('cover'); ?>><?php echo $user['access_cover'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('statistics'); ?>><?php echo $user['access_statistics'] ? $check : $uncheck; ?></td>
	<td class="matrix" <?php echo accessInfoTitle('admin'); ?>><?php echo $user['access_admin'] ? $check : $uncheck; ?></td>
	<td></td>
	<td><a href="users.php?action=deleteUser&amp;user_id=<?php echo $user['user_id']; ?>&amp;sign=<?php echo $cfg['sign']; ?>" onclick="return confirm('Are you sure you want to delete user: <?php echo html(addslashes($user['username'])); ?>?');"><img src="<?php echo $cfg['img']; ?>small_delete.png" alt="" class="small"></a></td>
	<td></td>
</tr>
<?php
	}
	echo '</table>' . "\n";
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Edit user                                                              |
//  +------------------------------------------------------------------------+
function editUser() {
	global $cfg, $db;
	authenticate('access_admin');

	$user_id =  @$_GET['user_id'];

	if ($user_id == '0') {
		// Add user configuraton
		$user['username']			= 'user_' . randomHex(4);
		$user['access_media']		= true;
		$user['access_popular']		= false;
		$user['access_favorite']	= false;
		$user['access_cover']		= false;
		$user['access_stream']		= false;
		$user['access_download']	= false;
		$user['access_upload']		= false;
		$user['access_play']		= false;
		$user['access_statistics']	= false;
		$user['access_admin']		= false;
		$user['access_search']		= 255;
		$password_text				= 'Password:';
		$confirm_text				= 'Confirm password:';
	}
	else {
		// Edit user configutaion
		$query = mysqli_query($db, 'SELECT
			username,
			access_media,
			access_popular,
			access_favorite,
			access_cover,
			access_stream,
			access_download,
			access_upload,
			access_play,
			access_statistics,
			access_admin,
			access_search
			FROM user
			WHERE user_id = ' . (int) $user_id);
		$user = mysqli_fetch_assoc($query);
		$password_text = 'New password:';
		$confirm_text = 'Confirm new password:';
		if ($user == false)
			message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]user_id not found in database');
	}

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Configuration';
	$nav['url'][]	= 'config.php';
	$nav['name'][]	= 'Users';
	$nav['url'][]	= 'users.php';
	$nav['name'][]	= $user['username'];
	require_once('include/header.inc.php');

	// Store salt temporarily in the session database
	// After acepting a new password copy the salt to the user database
	$session_salt = randomBase64url();
	$scrypt_options = NJB_SCRYPT_OPTIONS;
	mysqli_query($db, 'UPDATE session
		SET salt	= "' . mysqli_real_escape_string($db, $session_salt) . '",
		scrypt_options	= "' . mysqli_real_escape_string($db, $scrypt_options) . '"
		WHERE sid	= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
?>
<form id="userform" action="users.php" method="post" onsubmit="hashPassword(); return false;" autocomplete="off">
	<input type="hidden" name="action" value="updateUser">
	<input type="hidden" name="user_id" value="<?php echo $user_id; ?>">
	<input type="hidden" name="hash" value="">
	<input type="hidden" name="sign" value="<?php echo $cfg['sign']; ?>">
<table class="border bottom_space">
<tr class="header">
	<td class="space"></td>
	<td>Access</td>
	<td class="space"></td>
</tr>
<tr class="odd" <?php echo accessInfoTitle('media'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_media" value="1" class="space"<?php if ($user['access_media']) echo ' checked'; ?>>Media</label></td>
	<td></td>
</tr>
<tr class="even" <?php echo accessInfoTitle('popular'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_popular" value="1" class="space"<?php if ($user['access_popular']) echo ' checked'; ?>>Popular</label></td>
	<td></td>
</tr>
<tr class="odd" <?php echo accessInfoTitle('favorite'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_favorite" value="1" class="space"<?php if ($user['access_favorite']) echo ' checked'; ?>>Favorite</label></td>
	<td></td>
</tr>
<tr class="even" <?php echo accessInfoTitle('play'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_play" value="1" class="space"<?php if ($user['access_play']) echo ' checked'; ?>>Play</label></td>
	<td></td>
</tr>
<tr class="odd" <?php echo accessInfoTitle('stream'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_stream" value="1" class="space"<?php if ($user['access_stream']) echo ' checked'; ?>>Stream</label></td>
	<td></td>
</tr>
<tr class="even" <?php echo accessInfoTitle('download'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_download" value="1" class="space"<?php if ($user['access_download']) echo ' checked'; ?>>Download</label></td>
	<td></td>
</tr>
<tr class="odd" <?php echo accessInfoTitle('upload'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_upload" value="1" class="space"<?php if ($user['access_upload']) echo ' checked'; ?>>Upload</label></td>
	<td></td>
</tr>
<tr class="even" <?php echo accessInfoTitle('cover'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_cover" value="1" class="space"<?php if ($user['access_cover']) echo ' checked'; ?>>Cover</label></td>
	<td></td>
</tr>
<tr class="odd" <?php echo accessInfoTitle('statistics'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_statistics" value="1" class="space"<?php if ($user['access_statistics']) echo ' checked'; ?>>Statistics</label></td>
	<td></td>
</tr>
<tr class="even" <?php echo accessInfoTitle('admin'); ?>>
	<td></td>
	<td><label><input type="checkbox" name="access_admin" value="1" class="space"<?php if ($user['access_admin']) echo ' checked'; ?>>Admin</label></td>
	<td></td>
</tr>
<tr class="section">
	<td class="space"></td>
	<td>Internet search</td>
	<td class="space"></td>
</tr>
<?php
	for ($i = 0; $i < count($cfg['search_name']); $i++) {
?>
<tr class="<?php echo ($i & 1) ? 'even' : 'odd'; ?>">
	<td></td>
	<td><label><input type="checkbox" name="access_search[]" value="<?php echo pow(2,$i); ?>" class="space"<?php if (pow(2,$i) & $user['access_search']) echo ' checked'; ?>><?php echo html($cfg['search_name'][$i]); ?></label></td>
	<td></td>
</tr>
<?php
	}
?>
<tr class="footer">
	<td></td>
	<td>Username:</td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><input type="text" name="username" value="<?php echo html($user['username']); ?>" maxlength="255" class="short" onkeyup="anonymousPassword();"></td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><?php echo html($password_text); ?></td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><input type="password" name="password1" class="short" onkeyup="vallidatePassword();" title="[b]A password must contain at least 8 characters including:[/b][br]Lowercase[br]Uppercase[br]Number or special character"></td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><?php echo html($confirm_text); ?></td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><input type="password" name="password2" class="short" onkeyup="vallidateIdentical();"></td>
	<td></td>
</tr>
<tr class="footer"><td colspan="3"></td></tr>
</table>
<a href="javascript:hashPassword();" class="button">save</a><!--
--><a href="users.php" class="button">cancel</a>
<input type="submit" style="display: none;">
</form>
<script>
function initialize() {
	anonymousPassword()
}


function hashPassword()	{
	var password1 = document.getElementsByName('password1')[0].value;
	var password2 = document.getElementsByName('password2')[0].value;

	if (password1 == password2 && password1.match(/(?=.*[a-z])(?=.*[A-Z])(?=.*[\d\W]).{8,}/)) {
		// Submit with password
		document.getElementsByName('password1')[0].value = '';
		document.getElementsByName('password2')[0].value = '';

		document.getElementsByName('username')[0].classList.add('readonly');
		document.getElementsByName('password1')[0].classList.add('readonly');
		document.getElementsByName('password2')[0].classList.add('readonly');

		scrypt(password1, '<?php echo $session_salt; ?>', <?php echo $scrypt_options; ?>, function(hash) {
			document.getElementsByName('hash')[0].value = hex_sha256(hash);
			document.getElementById('userform').submit();
		});
	}
	else if (!password1 && !password2){
		// Submit without password
		document.getElementById('userform').submit();
	}
}


function anonymousPassword() {
	if (document.getElementsByName('username')[0].value == '<?php echo html($cfg['anonymous_user']); ?>') {
		document.getElementsByName('password1')[0].value = '';
		document.getElementsByName('password2')[0].value = '';
		document.getElementsByName('password1')[0].classList.add('readonly');
		document.getElementsByName('password2')[0].classList.add('readonly');
		// document.getElementsByName('password')[0].disabled = true;
	}
	else {
		document.getElementsByName('password1')[0].classList.remove('readonly');
		document.getElementsByName('password2')[0].classList.remove('readonly');
		// document.getElementsByName('password')[0].disabled = false;
	}
}


function vallidatePassword() {
	var password1 = document.getElementsByName('password1')[0].value;
	if (password1 && !password1.match(/(?=.*[a-z])(?=.*[A-Z])(?=.*[\d\W]).{8,}/))
		document.getElementsByName('password1')[0].classList.add('error');
	else
		document.getElementsByName('password1')[0].classList.remove('error');
}


function vallidateIdentical() {
	var password1 = document.getElementsByName('password1')[0].value;
	var password2 = document.getElementsByName('password2')[0].value;
	if (password1 && password2 && (password1 != password2 || !password2.match(/(?=.*[a-z])(?=.*[A-Z])(?=.*[\d\W]).{8,}/)))
		document.getElementsByName('password2')[0].classList.add('error');
	else
		document.getElementsByName('password2')[0].classList.remove('error');
}
</script>
<?php
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Update user                                                            |
//  +------------------------------------------------------------------------+
function updateUser() {
	global $cfg, $db;
	authenticate('access_admin', true, true);

	$user_id			= @$_POST['user_id'];
	$username			= @$_POST['username'];
	$hash				= ($username == $cfg['anonymous_user']) ? randomHex(64) : @$_POST['hash'];
	$access_media		= @$_POST['access_media']		? 1 : 0;
	$access_popular		= @$_POST['access_popular']		? 1 : 0;
	$access_favorite	= @$_POST['access_favorite']	? 1 : 0;
	$access_play		= @$_POST['access_play']		? 1 : 0;
	$access_stream		= @$_POST['access_stream']		? 1 : 0;
	$access_download	= @$_POST['access_download']	? 1 : 0;
	$access_upload		= @$_POST['access_upload']		? 1 : 0;
	$access_cover		= @$_POST['access_cover']		? 1 : 0;
	$access_statistics	= @$_POST['access_statistics']	? 1 : 0;
	$access_admin		= @$_POST['access_admin']		? 1 : 0;
	$access_search_array= @$_POST['access_search'];

	$access_search = 0;
	for ($i = 0; $i < count($access_search_array) && $i < 7; $i++)
		$access_search += (int) $access_search_array[$i];

	$query = mysqli_query($db, 'SELECT user_id FROM user WHERE user_id = ' . (int) $user_id);
	if (mysqli_fetch_row($query) == false && $user_id != '0')
		message(__FILE__, __LINE__, 'error', '[b]Error[/b][br]user_id not found in database');

	$query = mysqli_query($db, 'SELECT user_id FROM user WHERE user_id != ' . (int) $user_id . ' AND username = "' . mysqli_real_escape_string($db, $username) . '"');
	if (mysqli_fetch_row($query))
		message(__FILE__, __LINE__, 'warning', '[b]Username already exist[/b][br]Choose another username[br][url=users.php?action=editUser&user_id='. rawurlencode($user_id) . '][img]small_back.png[/img]Back to previous page[/url]');

	if ($hash != '' && preg_match('#^[0-9a-f]{64}$#', $hash) == false)	message(__FILE__, __LINE__, 'error', '[b]Password error[/b][br]Invalid password hash');
	if ($hash == '' && $user_id == '0')									message(__FILE__, __LINE__, 'warning', '[b]Password must be set for a new user[/b][br][url=users.php?action=editUser&user_id=0][img]small_back.png[/img]Back to previous page[/url]');
	if ($username == '')		 										message(__FILE__, __LINE__, 'warning', '[b]Username must be set[/b][br][url=users.php?action=editUser&user_id='. rawurlencode($user_id) .'][img]small_back.png[/img]Back to previous page[/url]');
	if ($access_admin == false && checkAdminAcount($user_id) == false)	message(__FILE__, __LINE__, 'warning', '[b]There must be at least one user with admin privilege[/b][br][url=users.php?action=editUser&user_id='. rawurlencode($user_id) .'][img]small_back.png[/img]Back to previous page[/url]');

	if ($user_id == '0') {
		mysqli_query($db, 'INSERT INTO user (username) VALUES ("")');
		$user_id = mysqli_insert_id($db);
	}

	$query = mysqli_query($db, 'SELECT salt, scrypt_options FROM session
		WHERE sid = BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
	$session = mysqli_fetch_assoc($query);

	if ($hash) {
		mysqli_query($db, 'UPDATE user SET
			username			= "' . mysqli_real_escape_string($db, $username) . '",
			password			= "' . mysqli_real_escape_string($db, $hash) . '",
			salt				= "' . mysqli_real_escape_string($db, $session['salt']) . '",
			scrypt_options		= "' . mysqli_real_escape_string($db, $session['scrypt_options']) . '",
			access_media		= ' . (int) $access_media . ',
			access_popular		= ' . (int) $access_popular . ',
			access_favorite 	= ' . (int) $access_favorite . ',
			access_play			= ' . (int) $access_play . ',
			access_stream		= ' . (int) $access_stream . ',
			access_download		= ' . (int) $access_download . ',
			access_upload		= ' . (int) $access_upload . ',
			access_cover		= ' . (int) $access_cover . ',
			access_statistics	= ' . (int) $access_statistics . ',
			access_admin		= ' . (int) $access_admin . ',
			access_search		= ' . (int) $access_search . '
			WHERE user_id		= ' . (int) $user_id);

		mysqli_query($db, 'UPDATE session
			SET logged_in	= 0
			WHERE user_id	= ' . (int) $user_id);
	}
	else {
		mysqli_query($db, 'UPDATE user SET
			username			= "' . mysqli_real_escape_string($db, $username) . '",
			access_media		= ' . (int) $access_media . ',
			access_popular		= ' . (int) $access_popular . ',
			access_favorite		= ' . (int) $access_favorite . ',
			access_play			= ' . (int) $access_play . ',
			access_stream		= ' . (int) $access_stream . ',
			access_download 	= ' . (int) $access_download . ',
			access_upload	 	= ' . (int) $access_upload . ',
			access_cover		= ' . (int) $access_cover . ',
			access_statistics	= ' . (int) $access_statistics . ',
			access_admin		= ' . (int) $access_admin . ',
			access_search		= ' . (int) $access_search . '
			WHERE user_id		= ' . (int) $user_id);
	}
}




//  +------------------------------------------------------------------------+
//  | Delete user                                                            |
//  +------------------------------------------------------------------------+
function deleteUser() {
	global $db;
	authenticate('access_admin', true, true);

	$user_id = @$_GET['user_id'];

	if (checkAdminAcount($user_id) == false)
		message(__FILE__, __LINE__, 'warning', '[b]There must be at least one user with admin privilege[/b][br][url=users.php][img]small_back.png[/img]Back to previous page[/url]');
	mysqli_query($db, 'DELETE FROM user WHERE user_id = ' . (int) $user_id);
	mysqli_query($db, 'DELETE FROM session WHERE user_id = ' . (int) $user_id);
}




//  +------------------------------------------------------------------------+
//  | Check admin acount                                                     |
//  +------------------------------------------------------------------------+
function checkAdminAcount($user_id) {
	global $db;
	$query = mysqli_query($db, 'SELECT user_id
		FROM user
		WHERE user_id != ' . (int) $user_id . '
		AND access_admin');
	$user = mysqli_fetch_assoc($query);
	if ($user['user_id'] == '') return false;
	else						return true;
}




//  +------------------------------------------------------------------------+
//  | Current user                                                           |
//  +------------------------------------------------------------------------+
function currentUser() {
	global $cfg, $db;
	authenticate('access_logged_in');

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Configuration';
	$nav['url'][]	= 'config.php';
	$nav['name'][]	= 'User';
	$nav['url'][]	= null;
	$nav['name'][]	= $cfg['username'];
	$nav['url'][]	= null;
	require_once('include/header.inc.php');

	$check = '<img src="' . $cfg['img'] . 'small_check.png" alt="" class="small space">';
	$uncheck = '<img src="' . $cfg['img'] . 'small_uncheck.png" alt="" class="small space">';

	if ($cfg['username'] != $cfg['anonymous_user']) {
		$query = mysqli_query($db, 'SELECT salt, scrypt_options
			FROM user
			WHERE user_id = ' . (int) $cfg['user_id']);
		$user = mysqli_fetch_assoc($query);

		// Store salt temporarily in the session database
		// After acepting a new password copy the salt to the user database
		$session_salt = randomBase64url();
		$session_scrypt_options = NJB_SCRYPT_OPTIONS;
		mysqli_query($db, 'UPDATE session
			SET salt	= "' . mysqli_real_escape_string($db, $session_salt) . '",
			scrypt_options	= "' . mysqli_real_escape_string($db, $session_scrypt_options) . '"
			WHERE sid	= BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
?>
<form id="userform" action="users.php" method="post" onsubmit="hashPassword(); return false;" autocomplete="off">
	<input type="hidden" name="action" value="updateCurrentUser">
	<input type="hidden" name="hash1" value="">
	<input type="hidden" name="hash2" value="">
	<input type="hidden" name="sign" value="<?php echo $cfg['sign']; ?>">
<?php
	} ?>
<table class="border bottom_space">
<tr class="header">
	<td class="space"></td>
	<td>Access&nbsp;right</td>
	<td class="space"></td>
</tr>
<tr class="odd mouseover" <?php echo accessInfoTitle('media'); ?>>
	<td></td>
	<td><?php echo $cfg['access_media'] ? $check : $uncheck; ?>Media</td>
	<td></td>
</tr>
<tr class="even mouseover" <?php echo accessInfoTitle('popular'); ?>>
	<td></td>
	<td><?php echo $cfg['access_popular'] ? $check : $uncheck; ?>Popular</td>
	<td></td>
</tr>
<tr class="odd mouseover" <?php echo accessInfoTitle('favorite'); ?>>
	<td></td>
	<td><?php echo $cfg['access_favorite'] ? $check : $uncheck; ?>Favorite</td>
	<td></td>
</tr>
<tr class="even mouseover" <?php echo accessInfoTitle('play'); ?>>
	<td></td>
	<td><?php echo $cfg['access_play'] ? $check : $uncheck; ?>Play</td>
	<td></td>
</tr>
<tr class="odd mouseover" <?php echo accessInfoTitle('stream'); ?>>
	<td></td>
	<td><?php echo $cfg['access_stream'] ? $check : $uncheck; ?>Stream</td>
	<td></td>
</tr>
<tr class="even mouseover" <?php echo accessInfoTitle('download'); ?>>
	<td></td>
	<td><?php echo $cfg['access_download'] ? $check : $uncheck; ?>Download</td>
	<td></td>
</tr>
<tr class="odd mouseover" <?php echo accessInfoTitle('upload'); ?>>
	<td></td>
	<td><?php echo $cfg['access_upload'] ? $check : $uncheck; ?>Upload</td>
	<td></td>
</tr>
<tr class="even mouseover" <?php echo accessInfoTitle('cover'); ?>>
	<td></td>
	<td><?php echo $cfg['access_cover'] ? $check : $uncheck; ?>Cover</td>
	<td></td>
</tr>
<tr class="odd mouseover" <?php echo accessInfoTitle('statistics'); ?>>
	<td></td>
	<td><?php echo $cfg['access_statistics'] ? $check : $uncheck; ?>Statistics</td>
	<td></td>
</tr>
<tr class="even mouseover" <?php echo accessInfoTitle('admin'); ?>>
	<td></td>
	<td><?php echo $cfg['access_admin'] ? $check : $uncheck; ?>Admin</td>
	<td></td>
</tr>
<?php
	if ($cfg['username'] != $cfg['anonymous_user']) { ?>
<tr class="footer">
	<td></td>
	<td>Current password:</td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><input type="password" name="password1" class="short"></td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td>New password:</td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><input type="password" name="password2" class="short" onkeyup="vallidatePassword();" title="[b]Your password must contain at least 8 characters including:[/b][br]Lowercase[br]Uppercase [br]Number or special character"></td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td>Confirm new password:</td>
	<td></td>
</tr>
<tr class="footer">
	<td></td>
	<td><input type="password" name="password3" class="short" onkeyup="vallidateIdentical();"></td>
	<td></td>
</tr>
<tr class="footer"><td colspan="3"></td></tr>
</table>
<a href="javascript:hashPassword();" class="button">save</a><!--
--><a href="config.php" class="button">cancel</a>
<input type="submit" style="display: none;">
</form>
<script>
function hashPassword()	{
	var password1 = document.getElementsByName('password1')[0].value;
	var password2 = document.getElementsByName('password2')[0].value;
	var password3 = document.getElementsByName('password3')[0].value;

	if (password1 && password2 == password3 && password2.match(/(?=.*[a-z])(?=.*[A-Z])(?=.*[\d\W]).{8,}/)) {
		// Submit password
		document.getElementsByName('password1')[0].classList.add('readonly');
		document.getElementsByName('password2')[0].classList.add('readonly');
		document.getElementsByName('password3')[0].classList.add('readonly');

		document.getElementsByName('password1')[0].value = '';
		document.getElementsByName('password2')[0].value = '';
		document.getElementsByName('password3')[0].value = '';

		scrypt(password1, '<?php echo $user['salt']; ?>', <?php echo $user['scrypt_options']; ?>, function(hash) {
			document.getElementsByName('hash1')[0].value = hash;
		});

		scrypt(password2, '<?php echo $session_salt; ?>', <?php echo $session_scrypt_options; ?>, function(hash) {
			document.getElementsByName('hash2')[0].value = hex_sha256(hash);
			document.getElementById('userform').submit();
		});

	}
}


function vallidatePassword() {
	var password2 = document.getElementsByName('password2')[0].value;
	if (password2 && !password2.match(/(?=.*[a-z])(?=.*[A-Z])(?=.*[\d\W]).{8,}/))
		document.getElementsByName('password2')[0].classList.add('error');
	else
		document.getElementsByName('password2')[0].classList.remove('error');
}


function vallidateIdentical() {
	var password2 = document.getElementsByName('password2')[0].value;
	var password3 = document.getElementsByName('password3')[0].value;
	if (password2 && password3 && (password2 != password3 || !password3.match(/(?=.*[a-z])(?=.*[A-Z])(?=.*[\d\W]).{8,}/)))
		document.getElementsByName('password3')[0].classList.add('error');
	else
		document.getElementsByName('password3')[0].classList.remove('error');
}
</script>
<?php
	}
	else
		echo '</table>' . "\n";
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Update current user                                                    |
//  +------------------------------------------------------------------------+
function updateCurrentUser() {
	global $cfg, $db;
	authenticate('access_logged_in', true, true);

	$hash1 = @$_POST['hash1'];
	$hash2 = @$_POST['hash2'];

	$query = mysqli_query($db, 'SELECT salt, scrypt_options
		FROM session
		WHERE sid = BINARY "' . mysqli_real_escape_string($db, $cfg['sid']) . '"');
	$session = mysqli_fetch_assoc($query);

	$query = mysqli_query($db, 'SELECT password, scrypt_options
		FROM user
		WHERE user_id = ' . (int) $cfg['user_id']);
	$user = mysqli_fetch_assoc($query);

	preg_match('#"dkLen":([0-9]{1,3})#', $user['scrypt_options'], $match);
	$scryptLenght = (isset($match[1])) ? $match[1] * 2 : 128; // Based on hex output

	if ($user['password'] != hash('sha256', $hash1))
		message(__FILE__, __LINE__, 'warning', '[b]Incorrect current password[/b][br][url=users.php?action=currentUser][img]small_back.png[/img]Back to previous page[/url]');

	if (preg_match('#^[0-9a-f]{' . $scryptLenght . '}$#', $hash1) == false || preg_match('#^[0-9a-f]{64}$#', $hash2) == false)
		message(__FILE__, __LINE__, 'error', '[b]Password error[/b][br]Invalid password hash');

	mysqli_query($db, 'UPDATE user SET
		password		= "' . mysqli_real_escape_string($db, $hash2) . '",
		salt			= "' . mysqli_real_escape_string($db, $session['salt']) . '",
		scrypt_options	= "' . mysqli_real_escape_string($db, $session['scrypt_options']) . '"
		WHERE user_id = ' . (int) $cfg['user_id']);

	header('Location: ' . NJB_HOME_URL . 'config.php');
	exit();
}




//  +------------------------------------------------------------------------+
//  | Online                                                                 |
//  +------------------------------------------------------------------------+
function online() {
	global $cfg, $db;
	authenticate('access_admin');

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Configuration';
	$nav['url'][]	= 'config.php';
	$nav['name'][]	= 'Online';
	require_once('include/header.inc.php');
	require_once('include/countrycode.inc.php');
?>
<table class="border bottom_space">
<tr class="header">
	<td class="space"></td>
	<td>User</td>
	<td class="textspace"></td>
	<td style="text-align:right">Visit</td>
	<td class="textspace"></td>
	<td style="text-align:right">Hit</td>
	<td class="textspace"></td>
	<td>IP</td>
	<td class="textspace"></td>
	<td>Country</td>
	<td class="textspace"></td>
	<td style="text-align:right">Idle</td>
	<td class="space"></td>
</tr>
<?php
	$i = 0;
	$geoip1_http_timeout = false;
	$geoip2_http_timeout = false;
	ini_set('default_socket_timeout', 5);
	$cfg['ip_tools'] = str_replace('&', '&amp;', $cfg['ip_tools']);
	$query = mysqli_query($db, 'SELECT logged_in, hit_counter, visit_counter, idle_time, ip, user_agent,
		user.username,
		user.user_id
		FROM session, user
		WHERE idle_time > ' . (int) (time() - 86400) . '
		AND hit_counter > 0
		AND session.user_id = user.user_id
		ORDER BY idle_time DESC');
	while ($session = mysqli_fetch_assoc($query)) {
		$country_name	= '';
		$flag			= '';


		if (filter_var($session['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE) == false)
			$country_name = 'Private range';
		elseif (filter_var($session['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_NO_RES_RANGE) == false)
			$country_name = 'Reserved range';
		else {
			$query2		= mysqli_query($db, 'SELECT code FROM country WHERE ip = "' . mysqli_real_escape_string($db, $session['ip']) . '" LIMIT 1');
			$country 	= mysqli_fetch_assoc($query2);
			$code		= $country['code'];

			if (array_key_exists($code, $code2country)) {
				$flag			= strtolower($code);
				$country_name	= $code2country[$code];
			}
		}


		if ($country_name == '' && filter_var($session['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) {
			// Get country code from IPV4
			$reverse_ip = explode('.', $session['ip']);
			$reverse_ip = array_reverse($reverse_ip);
			$reverse_ip = implode('.', $reverse_ip);
			$lookup = $reverse_ip . '.zz.countries.nerd.dk';
			$code = @gethostbyname($lookup);
			if ($code != $lookup) {
				$code = explode('.', $code);
				$code = 256 * (int) $code[2] + (int) $code[3];
				$code = $numeric2code[$code];

				if (array_key_exists($code, $code2country)) {
					$flag = strtolower($code);
					$country_name = $code2country[$code];
					mysqli_query($db, 'INSERT INTO country (ip, code) VALUES (
						"' . mysqli_real_escape_string($db, $session['ip']) . '",
						"' . mysqli_real_escape_string($db, $code) . '")');
				}
			}
		}


		if ($country_name == '' && $geoip1_http_timeout == false && filter_var($session['ip'], FILTER_VALIDATE_IP)) {
			// Get country code from IPV4 or IPV6
			// Encoded IP addresses are not supported yet with the geoip.nekudo.com service.
			// This shouldn't be a security issue because all IP addresses are validated with filter_var() before transmitting.
			$json = @file_get_contents('http://geoip.nekudo.com/api/' . $session['ip'] . '/en/short');
			$responce = json_decode($json, true);
			$code = $responce['country']['code'];

			if ($json === false)
				$geoip1_http_timeout = true;
			elseif (array_key_exists($code, $code2country)) {
				$flag = strtolower($code);
				$country_name = $code2country[$code];
				mysqli_query($db, 'INSERT INTO country (ip, code) VALUES (
					"' . mysqli_real_escape_string($db, $session['ip']) . '",
					"' . mysqli_real_escape_string($db, $code) . '")');
			}
		}


		if ($country_name == '' && $geoip2_http_timeout == false && filter_var($session['ip'], FILTER_VALIDATE_IP)) {
			// Get country code from IPV4 or IPV6
			$json = @file_get_contents('http://freegeoip.net/json/' . rawurlencode($session['ip']));
			$responce = json_decode($json, true);
			$code = $responce['country_code'];

			if ($json === false)
				$geoip2_http_timeout = true;
			elseif (array_key_exists($code, $code2country)) {
				$flag = strtolower($code);
				$country_name = $code2country[$code];
				mysqli_query($db, 'INSERT INTO country (ip, code) VALUES (
					"' . mysqli_real_escape_string($db, $session['ip']) . '",
					"' . mysqli_real_escape_string($db, $code) . '")');
			}
		}


		if ($country_name == '')
			$country_name = 'Unresolved';
?>
<tr class="<?php echo ($i++ & 1) ? 'even' : 'odd'; ?> mouseover">
	<td></td>
	<td><a href="users.php?action=editUser&amp;user_id=<?php echo $session['user_id'];?>" title="<?php echo html($session['user_agent']); ?>"><img src="<?php echo $cfg['img']; ?>small_<?php echo ($session['logged_in']) ? 'login' : 'logout'; ?>.png" alt="" class="small space"><?php echo html($session['username']); ?></a></td>
	<td></td>
	<td style="text-align:right"><?php echo $session['visit_counter']; ?></td>
	<td></td>
	<td style="text-align:right"><?php echo $session['hit_counter']; ?></td>
	<td></td>
	<td><a href="<?php echo str_replace('%ip', rawurlencode($session['ip']), $cfg['ip_tools']); ?>"><?php echo html($session['ip']); ?></a></td>
	<td></td>
	<td><span class="flag <?php echo $flag; ?>"></span><?php echo html($country_name); ?></td>
	<td></td>
	<td style="text-align:right"><?php echo formattedTime((time() - $session['idle_time']) * 1000); ?></td>
	<td></td>
</tr>
<?php
	}
	$query = mysqli_query($db, 'SELECT idle_time AS start_time FROM session WHERE logged_in ORDER BY idle_time ASC LIMIT 1');
	$session = mysqli_fetch_assoc($query);
?>
<tr class="footer">
	<td class="space"></td>
	<td colspan="11">Visit and hit count since: <?php echo date($cfg['date_format'], $session['start_time']); ?></td>
	<td class="space"></td>
</tr>
</table>
<a href="users.php?action=online" class="button">refresh</a><!--
--><a href="users.php?action=resetSessions&amp;sign=<?php echo $cfg['sign']; ?>" onclick="return confirm('Are you sure you want to reset all sessions?')" class="button">reset</a>
<?php
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Reset sessions                                                         |
//  +------------------------------------------------------------------------+
function resetSessions() {
	global $db;
	authenticate('access_admin', true, true);

	mysqli_query($db, 'TRUNCATE TABLE session');
	mysqli_query($db, 'TRUNCATE TABLE country');
}




//  +------------------------------------------------------------------------+
//  | User statistics                                                        |
//  +------------------------------------------------------------------------+
function userStatistics() {
	global $cfg, $db;
	authenticate('access_admin');

	$period = @$_GET['period'];

	if		($period == 'recent')	$timestamp = time() + 3600;
	elseif	($period == 'month')	$timestamp = time() - 86400 * 31;
	elseif	($period == 'year')		$timestamp = time() - 86400 * 365;
	else							message(__FILE__, __LINE__, 'error', '[b]Unsupported input value for[/b][br]period');

	// Navigator
	$nav			= array();
	$nav['name'][]	= 'Configuration';
	$nav['url'][]	= 'config.php';
	$nav['name'][]	= 'User statistics';
	require_once('include/header.inc.php');
?>
<table class="bottom_space"><tr><td><!-- table tab wrapper -->
<ul id="tab">
	<li class="tab <?php echo ($period == 'recent') ? 'on' : 'off'; ?>" onclick="location.href='users.php?action=userStatistics&amp;period=recent';">Recent</li>
	<li class="tab <?php echo ($period == 'month') ? 'on' : 'off'; ?>" onclick="location.href='users.php?action=userStatistics&amp;period=month';">Month</li>
	<li class="tab <?php echo ($period == 'year') ? 'on' : 'off'; ?>" onclick="location.href='users.php?action=userStatistics&amp;period=year';">Year</li>
</ul>
<table class="tab">
<tr class="header">
	<td class="space"></td>
	<td>Username</td>
	<td class="textspace"></td>
	<td class="matrix">Play</td>
	<td class="matrix">Stream</td>
	<td class="matrix">Download</td>
	<td class="matrix">Cover</td>
	<td class="space"></td>
</tr>
<?php
	$i= 0;
	$query = mysqli_query($db, 'SELECT username, access_play, access_stream, access_download, access_cover, user_id FROM user ORDER BY username');
	while ($user = mysqli_fetch_assoc($query)) {
		$n[0] = $n[1] = $n[2] = $n[3] = $n[4] = 0;
		$query2 = mysqli_query($db, 'SELECT flag, COUNT(*) AS counter
			FROM counter
			WHERE user_id = "' . (int) $user['user_id'] . '"
			AND time > ' . (int) $timestamp . '
			GROUP BY flag');
		while (($period != 'recent') && $album = mysqli_fetch_assoc($query2)) {
			$n[ $album['flag'] ] = $album['counter'];
		}
?>
<tr class="<?php if ($cfg['username'] == $user['username']) echo 'select'; else echo ($i & 1) ? 'even mouseover' : 'odd mouseover'; $i++ ?>">
	<td ></td>
	<td class="nowrap"><a href="users.php?action=editUser&amp;user_id=<?php echo $user['user_id']; ?>"><img src="<?php echo $cfg['img']; ?>small_user.png" alt="" class="small space"><?php echo html($user['username']); ?></a></td>
	<td></td>
	<td class="matrix"><?php echo ($user['access_play'])	? '<a href="index.php?action=viewPopular&amp;flag=0&amp;period=' . $period . '&amp;user_id=' . $user['user_id'] . '">' . (($period == 'recent') ? '<img src="' . $cfg['img'] . 'small_check.png" alt="" class="small">' : $n[0]) . '</a>' : '<img src="' . $cfg['img'] . 'small_uncheck.png" alt="" class="small">'; ?></td>
	<td class="matrix"><?php echo ($user['access_stream']) ? '<a href="index.php?action=viewPopular&amp;flag=1&amp;period=' . $period . '&amp;user_id=' . $user['user_id'] . '">' . (($period == 'recent') ? '<img src="' . $cfg['img'] . 'small_check.png" alt="" class="small">' : $n[1]) . '</a>' : '<img src="' . $cfg['img'] . 'small_uncheck.png" alt="" class="small">'; ?></td>
	<td class="matrix"><?php echo ($user['access_download']) ? '<a href="index.php?action=viewPopular&amp;flag=2&amp;period=' . $period . '&amp;user_id=' . $user['user_id'] . '">' . (($period == 'recent') ? '<img src="' . $cfg['img'] . 'small_check.png" alt="" class="small">' : $n[2]) . '</a>' : '<img src="' . $cfg['img'] . 'small_uncheck.png" alt="" class="small">'; ?></td>
	<td class="matrix"><?php echo ($user['access_cover']) ? '<a href="index.php?action=viewPopular&amp;flag=3&amp;period=' . $period . '&amp;user_id=' . $user['user_id'] . '">' . (($period == 'recent') ? '<img src="' . $cfg['img'] . 'small_check.png" alt="" class="small">' : $n[3]) . '</a>' : '<img src="' . $cfg['img'] . 'small_uncheck.png" alt="" class="small">'; ?></td>
	<td></td>
</tr>
<?php
	}
	if ($period != 'recent') {
		$n[0] = $n[1] = $n[2] = $n[3] = 0;
		$query = mysqli_query($db, 'SELECT flag, COUNT(*) AS counter
			FROM counter
			WHERE time > ' . (int) $timestamp . '
			GROUP BY flag');
		while ($album = mysqli_fetch_assoc($query)) {
			$n[ $album['flag'] ] = $album['counter'];
		}
?>
<tr class="footer">
	<td></td>
	<td><img src="<?php echo $cfg['img']; ?>small_users.png" alt="" class="small space">All users</td>
	<td></td>
	<td class="matrix"><?php echo $n[NJB_COUNTER_PLAY]; ?></td>
	<td class="matrix"><?php echo $n[NJB_COUNTER_STREAM]; ?></td>
	<td class="matrix"><?php echo $n[NJB_COUNTER_DOWNLOAD]; ?></td>
	<td class="matrix"><?php echo $n[NJB_COUNTER_COVER]; ?></td>
	<td></td>
</tr>
<?php
	} ?>
</table>
</td></tr></table><!-- table tab wrapper -->
<a href="users.php?action=userStatistics&amp;period=<?php echo $period; ?>" class="button">refresh</a><!--
--><a href="users.php?action=resetUserStatistics&amp;period=<?php echo $period; ?>&amp;sign=<?php echo $cfg['sign']; ?>" onclick="return confirm('Are you sure you want to reset all user statistics?')" class="button">reset</a>
<?php
	require_once('include/footer.inc.php');
}




//  +------------------------------------------------------------------------+
//  | Reset user statistics                                                  |
//  +------------------------------------------------------------------------+
function resetUserStatistics() {
	global $db;
	authenticate('access_admin', true, true);

	mysqli_query($db, 'TRUNCATE TABLE counter');
}
