-- phpMyAdmin SQL Dump
-- version 2.6.1-pl3
-- http://www.phpmyadmin.net
-- 
-- Database: `netjukebox`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `album`
-- 

CREATE TABLE `album` (
  `artist` varchar(255) NOT NULL default '',
  `artist_alphabetic` varchar(255) NOT NULL default '',
  `album` varchar(255) NOT NULL default '',
  `year` int(2) unsigned default NULL,
  `month` int(1) unsigned default NULL,
  `genre_id` varchar(10) NOT NULL default '',
  `counter` int(8) unsigned NOT NULL default '0',
  `counter_update_time` int(10) unsigned NOT NULL default '0',
  `album_add_time` int(10) unsigned NOT NULL default '0',
  `cds` int(1) unsigned NOT NULL default '0',
  `album_id` varchar(32) NOT NULL default '',
  `updated` enum('N','Y') NOT NULL default 'Y',
  KEY `album` (`album`),
  KEY `genre_id` (`genre_id`),
  KEY `artist_alphabetic` (`artist_alphabetic`),
  KEY `updated` (`updated`),
  KEY `year` (`year`,`month`),
  KEY `artist` (`artist`),
  KEY `album_id` (`album_id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `bitmap`
-- 

CREATE TABLE `bitmap` (
  `image50` mediumblob NOT NULL,
  `image100` mediumblob NOT NULL,
  `image200` mediumblob NOT NULL,
  `filemtime` int(10) unsigned NOT NULL default '0',
  `cd_front` varchar(255) NOT NULL default '',
  `cd_back` varchar(255) NOT NULL default '',
  `album_id` varchar(32) NOT NULL default '',
  `updated` enum('N','Y') NOT NULL default 'Y',
  KEY `album_id` (`album_id`),
  KEY `filemtime` (`filemtime`),
  KEY `cd_front` (`cd_front`),
  KEY `cd_back` (`cd_back`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `configuration_database`
-- 

CREATE TABLE `configuration_database` (
  `version` tinyint(4) NOT NULL default '0',
  KEY `version` (`version`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `configuration_httpq`
-- 

CREATE TABLE `configuration_httpq` (
  `name` varchar(255) NOT NULL default '',
  `httpq_host` varchar(255) NOT NULL default '',
  `httpq_port` varchar(5) NOT NULL default '',
  `httpq_pass` varchar(255) NOT NULL default '',
  `media_share` varchar(255) NOT NULL default '',
  `httpq_id` int(10) NOT NULL auto_increment,
  PRIMARY KEY  (`httpq_id`),
  KEY `name` (`name`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `configuration_users`
-- 

CREATE TABLE `configuration_users` (
  `username` varchar(255) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `access_browse` enum('N','Y') NOT NULL default 'N',
  `access_favorites` enum('N','Y') NOT NULL default 'N',
  `access_play` enum('N','Y') NOT NULL default 'N',
  `access_record` enum('N','Y') NOT NULL default 'N',
  `access_download` enum('N','Y') NOT NULL default 'N',
  `access_stream` enum('N','Y') NOT NULL default 'N',
  `access_cover` enum('N','Y') NOT NULL default 'N',
  `access_config` enum('N','Y') NOT NULL default 'N',
  `stream_id` int(10) NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`user_id`),
  KEY `username` (`username`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `favorites`
-- 

CREATE TABLE `favorites` (
  `name` varchar(255) NOT NULL default '',
  `comment` varchar(255) NOT NULL default '',
  `stream` enum('N','Y') NOT NULL default 'N',
  `favorites_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`favorites_id`),
  KEY `comment` (`comment`),
  KEY `name` (`name`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `favoritesitems`
-- 

CREATE TABLE `favoritesitems` (
  `track_id` varchar(41) NOT NULL default '',
  `stream_url` varchar(255) NOT NULL default '',
  `position` int(10) unsigned NOT NULL default '0',
  `favorites_id` int(10) unsigned NOT NULL default '0',
  KEY `favorites_id` (`favorites_id`,`position`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `genre`
-- 

CREATE TABLE `genre` (
  `genre_id` varchar(10) NOT NULL default '',
  `genre` varchar(255) NOT NULL default '',
  KEY `genre` (`genre`),
  KEY `genre_id` (`genre_id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `track`
-- 

CREATE TABLE `track` (
  `artist` varchar(255) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `featuring` varchar(255) NOT NULL default '',
  `relative_file` varchar(255) NOT NULL default '',
  `filemtime` int(10) unsigned NOT NULL default '0',
  `playtime` varchar(8) NOT NULL default '',
  `playtime_miliseconds` int(10) unsigned NOT NULL default '0',
  `file_size` int(10) unsigned NOT NULL default '0',
  `audio_bitrate` int(10) unsigned NOT NULL default '0',
  `audio_raw_decoded` int(10) unsigned NOT NULL default '0',
  `audio_bits_per_sample` int(10) unsigned NOT NULL default '0',
  `audio_sample_rate` int(10) unsigned NOT NULL default '0',
  `audio_channels` int(4) unsigned NOT NULL default '0',
  `audio_dataformat` varchar(64) NOT NULL default '',
  `audio_encoder` varchar(64) NOT NULL default '',
  `audio_profile` varchar(64) NOT NULL default '',
  `video_dataformat` varchar(64) NOT NULL default '',
  `video_codec` varchar(64) NOT NULL default '',
  `video_resolution_x` int(10) unsigned NOT NULL default '0',
  `video_resolution_y` int(10) unsigned NOT NULL default '0',
  `video_framerate` int(10) unsigned NOT NULL default '0',
  `cd` int(4) unsigned NOT NULL default '0',
  `album_id` varchar(32) NOT NULL default '',
  `track_id` varchar(41) NOT NULL default '',
  `updated` enum('N','Y') NOT NULL default 'Y',
  KEY `cd` (`cd`),
  KEY `artist` (`artist`),
  KEY `title` (`title`),
  KEY `relative_file` (`relative_file`),
  KEY `track_id` (`track_id`),
  KEY `album_id` (`album_id`,`cd`),
  KEY `updated` (`updated`),
  KEY `audio_dataformat` (`audio_dataformat`),
  KEY `video_dataformat` (`video_dataformat`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Dumping data for table `genre` (genre example)
-- 

INSERT INTO genre VALUES ('a', 'Pop');
INSERT INTO genre VALUES ('aa', 'Rock');
INSERT INTO genre VALUES ('ab', 'Alternative');
INSERT INTO genre VALUES ('b', 'Soul');
INSERT INTO genre VALUES ('ba', 'R&B');
INSERT INTO genre VALUES ('c', 'Dance');
INSERT INTO genre VALUES ('ca', 'Triphop');
INSERT INTO genre VALUES ('cb', 'Rap & Hiphop');
INSERT INTO genre VALUES ('cc', 'Ambient');
INSERT INTO genre VALUES ('d', 'Roots');
INSERT INTO genre VALUES ('da', 'World');
INSERT INTO genre VALUES ('db', 'Folk');
INSERT INTO genre VALUES ('dc', 'Blues');
INSERT INTO genre VALUES ('e', 'Jazz');
INSERT INTO genre VALUES ('f', 'Klasiek');
INSERT INTO genre VALUES ('g', 'Cabaret');
INSERT INTO genre VALUES ('h', 'Video');
INSERT INTO genre VALUES ('de', 'Country');
INSERT INTO genre VALUES ('df', 'Regea');
INSERT INTO genre VALUES ('i', 'Soundtrack');

-- --------------------------------------------------------

--
-- Dumping data for table `configuration_users`
--

INSERT INTO configuration_users VALUES ('admin', '21232f297a57a5a743894a0e4a801fc3', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 'Y', 0, 1);

-- --------------------------------------------------------

--
-- Database version
--

INSERT INTO configuration_database VALUES (8);
